/* AppRow.c generated by valac 0.56.17, the Vala compiler
 * generated from AppRow.vala, do not modify */

/*
* SPDX-License-Identifier: LGPL-3.0-or-later
* SPDX-FileCopyrightText: 2023 elementary, Inc. (https://elementary.io)
*
* Authored by: Leonhard Kargl <leo.kargl@proton.me>
*/

#include "io.elementary.settings.sound.h"
#include <gtk/gtk.h>
#include <glib.h>
#include <stdlib.h>
#include <string.h>
#include <float.h>
#include <math.h>
#include <glib/gi18n-lib.h>
#include <gio/gio.h>
#include <glib-object.h>
#include <pango/pango.h>
#include <granite-7.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	SOUND_APP_ROW_0_PROPERTY,
	SOUND_APP_ROW_NUM_PROPERTIES
};
static GParamSpec* sound_app_row_properties[SOUND_APP_ROW_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _Block2Data Block2Data;

struct _SoundAppRowPrivate {
	SoundApp* app;
	GtkLabel* app_name_label;
	GtkLabel* media_name_label;
	GtkImage* image;
	GtkButton* icon_button;
	GtkScale* volume_scale;
	GtkSwitch* mute_switch;
};

struct _Block2Data {
	int _ref_count_;
	SoundAppRow* self;
	SoundApp* app;
};

static gint SoundAppRow_private_offset;
static gpointer sound_app_row_parent_class = NULL;

static void sound_app_row_toggle_mute_application (SoundAppRow* self,
                                            gboolean* custom);
static void sound_app_row_update (SoundAppRow* self);
static Block2Data* block2_data_ref (Block2Data* _data2_);
static void block2_data_unref (void * _userdata_);
static void _sound_app_row_update_sound_app_changed (SoundApp* _sender,
                                              gpointer self);
static void __lambda17_ (Block2Data* _data2_);
static void ___lambda17__g_object_notify (GObject* _sender,
                                   GParamSpec* pspec,
                                   gpointer self);
static GObject * sound_app_row_constructor (GType type,
                                     guint n_construct_properties,
                                     GObjectConstructParam * construct_properties);
static gboolean _sound_app_row___lambda18_ (SoundAppRow* self,
                                     GtkScrollType type,
                                     gdouble new_value);
static gboolean __sound_app_row___lambda18__gtk_range_change_value (GtkRange* _sender,
                                                             GtkScrollType scroll,
                                                             gdouble new_value,
                                                             gpointer self);
static void _sound_app_row___lambda19_ (SoundAppRow* self);
static void __sound_app_row___lambda19__gtk_button_clicked (GtkButton* _sender,
                                                     gpointer self);
static gboolean _sound_app_row___lambda20_ (SoundAppRow* self,
                                     gboolean state);
static gboolean __sound_app_row___lambda20__gtk_switch_state_set (GtkSwitch* _sender,
                                                           gboolean state,
                                                           gpointer self);
static void sound_app_row_finalize (GObject * obj);
static GType sound_app_row_get_type_once (void);

static inline gpointer
sound_app_row_get_instance_private (SoundAppRow* self)
{
	return G_STRUCT_MEMBER_P (self, SoundAppRow_private_offset);
}

static void
sound_app_row_toggle_mute_application (SoundAppRow* self,
                                       gboolean* custom)
{
	SoundApp* _tmp0_;
	gboolean* _tmp1_ = NULL;
	SoundPulseAudioManager* _tmp6_;
	SoundApp* _tmp7_;
#line 74 "../src/AppRow.vala"
	g_return_if_fail (self != NULL);
#line 75 "../src/AppRow.vala"
	_tmp0_ = self->priv->app;
#line 75 "../src/AppRow.vala"
	if (_tmp0_ == NULL) {
#line 76 "../src/AppRow.vala"
		return;
#line 115 "AppRow.c"
	}
#line 79 "../src/AppRow.vala"
	if (custom != NULL) {
#line 79 "../src/AppRow.vala"
		_tmp1_ = custom;
#line 121 "AppRow.c"
	} else {
		SoundApp* _tmp2_;
		gboolean _tmp3_;
		gboolean _tmp4_;
		gboolean _tmp5_;
#line 79 "../src/AppRow.vala"
		_tmp2_ = self->priv->app;
#line 79 "../src/AppRow.vala"
		_tmp3_ = sound_app_get_muted (_tmp2_);
#line 79 "../src/AppRow.vala"
		_tmp4_ = _tmp3_;
#line 79 "../src/AppRow.vala"
		_tmp5_ = !_tmp4_;
#line 79 "../src/AppRow.vala"
		_tmp1_ = &_tmp5_;
#line 137 "AppRow.c"
	}
#line 79 "../src/AppRow.vala"
	_tmp6_ = sound_pulse_audio_manager_get_default ();
#line 79 "../src/AppRow.vala"
	_tmp7_ = self->priv->app;
#line 79 "../src/AppRow.vala"
	sound_pulse_audio_manager_mute_application (_tmp6_, _tmp7_, *_tmp1_);
#line 145 "AppRow.c"
}

static void
sound_app_row_update (SoundAppRow* self)
{
	GtkLabel* _tmp0_;
	GtkLabel* _tmp1_;
	SoundApp* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	GtkScale* _tmp5_;
	SoundApp* _tmp6_;
	gdouble _tmp7_;
	gdouble _tmp8_;
	GtkSwitch* _tmp9_;
	SoundApp* _tmp10_;
	gboolean _tmp11_;
	gboolean _tmp12_;
	GtkScale* _tmp13_;
	SoundApp* _tmp14_;
	gboolean _tmp15_;
	gboolean _tmp16_;
	SoundApp* _tmp17_;
	gboolean _tmp18_;
	gboolean _tmp19_;
	SoundApp* _tmp26_;
	gboolean _tmp27_;
	gboolean _tmp28_;
#line 82 "../src/AppRow.vala"
	g_return_if_fail (self != NULL);
#line 83 "../src/AppRow.vala"
	_tmp0_ = self->priv->media_name_label;
#line 83 "../src/AppRow.vala"
	_tmp1_ = self->priv->media_name_label;
#line 83 "../src/AppRow.vala"
	_tmp2_ = self->priv->app;
#line 83 "../src/AppRow.vala"
	_tmp3_ = sound_app_get_media_name (_tmp2_);
#line 83 "../src/AppRow.vala"
	_tmp4_ = _tmp3_;
#line 83 "../src/AppRow.vala"
	gtk_widget_set_tooltip_text ((GtkWidget*) _tmp1_, _tmp4_);
#line 83 "../src/AppRow.vala"
	gtk_label_set_label (_tmp0_, _tmp4_);
#line 84 "../src/AppRow.vala"
	_tmp5_ = self->priv->volume_scale;
#line 84 "../src/AppRow.vala"
	_tmp6_ = self->priv->app;
#line 84 "../src/AppRow.vala"
	_tmp7_ = sound_app_get_volume (_tmp6_);
#line 84 "../src/AppRow.vala"
	_tmp8_ = _tmp7_;
#line 84 "../src/AppRow.vala"
	gtk_range_set_value ((GtkRange*) _tmp5_, _tmp8_);
#line 85 "../src/AppRow.vala"
	_tmp9_ = self->priv->mute_switch;
#line 85 "../src/AppRow.vala"
	_tmp10_ = self->priv->app;
#line 85 "../src/AppRow.vala"
	_tmp11_ = sound_app_get_muted (_tmp10_);
#line 85 "../src/AppRow.vala"
	_tmp12_ = _tmp11_;
#line 85 "../src/AppRow.vala"
	gtk_switch_set_state (_tmp9_, !_tmp12_);
#line 86 "../src/AppRow.vala"
	_tmp13_ = self->priv->volume_scale;
#line 86 "../src/AppRow.vala"
	_tmp14_ = self->priv->app;
#line 86 "../src/AppRow.vala"
	_tmp15_ = sound_app_get_muted (_tmp14_);
#line 86 "../src/AppRow.vala"
	_tmp16_ = _tmp15_;
#line 86 "../src/AppRow.vala"
	gtk_widget_set_sensitive ((GtkWidget*) _tmp13_, !_tmp16_);
#line 88 "../src/AppRow.vala"
	_tmp17_ = self->priv->app;
#line 88 "../src/AppRow.vala"
	_tmp18_ = sound_app_get_muted (_tmp17_);
#line 88 "../src/AppRow.vala"
	_tmp19_ = _tmp18_;
#line 88 "../src/AppRow.vala"
	if (_tmp19_) {
#line 228 "AppRow.c"
		GtkButton* _tmp20_;
#line 89 "../src/AppRow.vala"
		_tmp20_ = self->priv->icon_button;
#line 89 "../src/AppRow.vala"
		gtk_button_set_icon_name (_tmp20_, "audio-volume-muted");
#line 234 "AppRow.c"
	} else {
		GtkScale* _tmp21_;
#line 90 "../src/AppRow.vala"
		_tmp21_ = self->priv->volume_scale;
#line 90 "../src/AppRow.vala"
		if (gtk_range_get_value ((GtkRange*) _tmp21_) < 0.33) {
#line 241 "AppRow.c"
			GtkButton* _tmp22_;
#line 91 "../src/AppRow.vala"
			_tmp22_ = self->priv->icon_button;
#line 91 "../src/AppRow.vala"
			gtk_button_set_icon_name (_tmp22_, "audio-volume-low");
#line 247 "AppRow.c"
		} else {
			GtkScale* _tmp23_;
#line 92 "../src/AppRow.vala"
			_tmp23_ = self->priv->volume_scale;
#line 92 "../src/AppRow.vala"
			if (gtk_range_get_value ((GtkRange*) _tmp23_) > 0.66) {
#line 254 "AppRow.c"
				GtkButton* _tmp24_;
#line 93 "../src/AppRow.vala"
				_tmp24_ = self->priv->icon_button;
#line 93 "../src/AppRow.vala"
				gtk_button_set_icon_name (_tmp24_, "audio-volume-high");
#line 260 "AppRow.c"
			} else {
				GtkButton* _tmp25_;
#line 95 "../src/AppRow.vala"
				_tmp25_ = self->priv->icon_button;
#line 95 "../src/AppRow.vala"
				gtk_button_set_icon_name (_tmp25_, "audio-volume-medium");
#line 267 "AppRow.c"
			}
		}
	}
#line 98 "../src/AppRow.vala"
	_tmp26_ = self->priv->app;
#line 98 "../src/AppRow.vala"
	_tmp27_ = sound_app_get_muted (_tmp26_);
#line 98 "../src/AppRow.vala"
	_tmp28_ = _tmp27_;
#line 98 "../src/AppRow.vala"
	if (_tmp28_) {
#line 279 "AppRow.c"
		GtkButton* _tmp29_;
#line 99 "../src/AppRow.vala"
		_tmp29_ = self->priv->icon_button;
#line 99 "../src/AppRow.vala"
		gtk_widget_set_tooltip_text ((GtkWidget*) _tmp29_, _ ("Unmute"));
#line 285 "AppRow.c"
	} else {
		GtkButton* _tmp30_;
#line 101 "../src/AppRow.vala"
		_tmp30_ = self->priv->icon_button;
#line 101 "../src/AppRow.vala"
		gtk_widget_set_tooltip_text ((GtkWidget*) _tmp30_, _ ("Mute"));
#line 292 "AppRow.c"
	}
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 105 "../src/AppRow.vala"
	return self ? g_object_ref (self) : NULL;
#line 301 "AppRow.c"
}

static Block2Data*
block2_data_ref (Block2Data* _data2_)
{
#line 105 "../src/AppRow.vala"
	g_atomic_int_inc (&_data2_->_ref_count_);
#line 105 "../src/AppRow.vala"
	return _data2_;
#line 311 "AppRow.c"
}

static void
block2_data_unref (void * _userdata_)
{
	Block2Data* _data2_;
	_data2_ = (Block2Data*) _userdata_;
#line 105 "../src/AppRow.vala"
	if (g_atomic_int_dec_and_test (&_data2_->_ref_count_)) {
#line 321 "AppRow.c"
		SoundAppRow* self;
#line 105 "../src/AppRow.vala"
		self = _data2_->self;
#line 105 "../src/AppRow.vala"
		_g_object_unref0 (_data2_->app);
#line 105 "../src/AppRow.vala"
		_g_object_unref0 (self);
#line 105 "../src/AppRow.vala"
		g_slice_free (Block2Data, _data2_);
#line 331 "AppRow.c"
	}
}

static void
_sound_app_row_update_sound_app_changed (SoundApp* _sender,
                                         gpointer self)
{
#line 111 "../src/AppRow.vala"
	sound_app_row_update ((SoundAppRow*) self);
#line 341 "AppRow.c"
}

static void
__lambda17_ (Block2Data* _data2_)
{
	SoundAppRow* self;
	gboolean _tmp0_;
	gboolean _tmp1_;
#line 112 "../src/AppRow.vala"
	self = _data2_->self;
#line 113 "../src/AppRow.vala"
	_tmp0_ = sound_app_get_hidden (_data2_->app);
#line 113 "../src/AppRow.vala"
	_tmp1_ = _tmp0_;
#line 113 "../src/AppRow.vala"
	gtk_widget_set_visible ((GtkWidget*) self, _tmp1_);
#line 358 "AppRow.c"
}

static void
___lambda17__g_object_notify (GObject* _sender,
                              GParamSpec* pspec,
                              gpointer self)
{
#line 112 "../src/AppRow.vala"
	__lambda17_ (self);
#line 368 "AppRow.c"
}

void
sound_app_row_bind_app (SoundAppRow* self,
                        SoundApp* app)
{
	Block2Data* _data2_;
	SoundApp* _tmp0_;
	SoundApp* _tmp1_;
	GtkLabel* _tmp2_;
	const gchar* _tmp3_;
	const gchar* _tmp4_;
	GtkImage* _tmp5_;
	GIcon* _tmp6_;
	GIcon* _tmp7_;
	gboolean _tmp8_;
	gboolean _tmp9_;
	GtkScale* _tmp10_;
	gdouble _tmp11_;
	gdouble _tmp12_;
#line 105 "../src/AppRow.vala"
	g_return_if_fail (self != NULL);
#line 105 "../src/AppRow.vala"
	g_return_if_fail (app != NULL);
#line 105 "../src/AppRow.vala"
	_data2_ = g_slice_new0 (Block2Data);
#line 105 "../src/AppRow.vala"
	_data2_->_ref_count_ = 1;
#line 105 "../src/AppRow.vala"
	_data2_->self = g_object_ref (self);
#line 105 "../src/AppRow.vala"
	_tmp0_ = _g_object_ref0 (app);
#line 105 "../src/AppRow.vala"
	_g_object_unref0 (_data2_->app);
#line 105 "../src/AppRow.vala"
	_data2_->app = _tmp0_;
#line 106 "../src/AppRow.vala"
	_tmp1_ = _g_object_ref0 (_data2_->app);
#line 106 "../src/AppRow.vala"
	_g_object_unref0 (self->priv->app);
#line 106 "../src/AppRow.vala"
	self->priv->app = _tmp1_;
#line 108 "../src/AppRow.vala"
	_tmp2_ = self->priv->app_name_label;
#line 108 "../src/AppRow.vala"
	_tmp3_ = sound_app_get_display_name (_data2_->app);
#line 108 "../src/AppRow.vala"
	_tmp4_ = _tmp3_;
#line 108 "../src/AppRow.vala"
	gtk_label_set_label (_tmp2_, _tmp4_);
#line 109 "../src/AppRow.vala"
	_tmp5_ = self->priv->image;
#line 109 "../src/AppRow.vala"
	_tmp6_ = sound_app_get_icon (_data2_->app);
#line 109 "../src/AppRow.vala"
	_tmp7_ = _tmp6_;
#line 109 "../src/AppRow.vala"
	gtk_image_set_from_gicon (_tmp5_, _tmp7_);
#line 111 "../src/AppRow.vala"
	g_signal_connect_object (_data2_->app, "changed", (GCallback) _sound_app_row_update_sound_app_changed, self, 0);
#line 112 "../src/AppRow.vala"
	g_signal_connect_data ((GObject*) _data2_->app, "notify::hidden", (GCallback) ___lambda17__g_object_notify, block2_data_ref (_data2_), (GClosureNotify) block2_data_unref, 0);
#line 116 "../src/AppRow.vala"
	_tmp8_ = sound_app_get_hidden (_data2_->app);
#line 116 "../src/AppRow.vala"
	_tmp9_ = _tmp8_;
#line 116 "../src/AppRow.vala"
	gtk_widget_set_visible ((GtkWidget*) self, _tmp9_);
#line 118 "../src/AppRow.vala"
	_tmp10_ = self->priv->volume_scale;
#line 118 "../src/AppRow.vala"
	_tmp11_ = sound_app_get_volume (_data2_->app);
#line 118 "../src/AppRow.vala"
	_tmp12_ = _tmp11_;
#line 118 "../src/AppRow.vala"
	gtk_range_set_value ((GtkRange*) _tmp10_, _tmp12_);
#line 105 "../src/AppRow.vala"
	block2_data_unref (_data2_);
#line 105 "../src/AppRow.vala"
	_data2_ = NULL;
#line 449 "AppRow.c"
}

void
sound_app_row_unbind_app (SoundAppRow* self)
{
	SoundApp* _tmp0_;
	guint _tmp1_;
#line 121 "../src/AppRow.vala"
	g_return_if_fail (self != NULL);
#line 122 "../src/AppRow.vala"
	_tmp0_ = self->priv->app;
#line 122 "../src/AppRow.vala"
	g_signal_parse_name ("changed", SOUND_TYPE_APP, &_tmp1_, NULL, FALSE);
#line 122 "../src/AppRow.vala"
	g_signal_handlers_disconnect_matched (_tmp0_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp1_, 0, NULL, (GCallback) _sound_app_row_update_sound_app_changed, self);
#line 465 "AppRow.c"
}

SoundAppRow*
sound_app_row_construct (GType object_type)
{
	SoundAppRow * self = NULL;
#line 8 "../src/AppRow.vala"
	self = (SoundAppRow*) g_object_new (object_type, NULL);
#line 8 "../src/AppRow.vala"
	return self;
#line 476 "AppRow.c"
}

SoundAppRow*
sound_app_row_new (void)
{
#line 8 "../src/AppRow.vala"
	return sound_app_row_construct (SOUND_TYPE_APP_ROW);
#line 484 "AppRow.c"
}

static gboolean
_sound_app_row___lambda18_ (SoundAppRow* self,
                            GtkScrollType type,
                            gdouble new_value)
{
	SoundApp* _tmp0_;
	gboolean result;
#line 59 "../src/AppRow.vala"
	_tmp0_ = self->priv->app;
#line 59 "../src/AppRow.vala"
	if (_tmp0_ != NULL) {
#line 498 "AppRow.c"
		SoundPulseAudioManager* _tmp1_;
		SoundApp* _tmp2_;
#line 60 "../src/AppRow.vala"
		_tmp1_ = sound_pulse_audio_manager_get_default ();
#line 60 "../src/AppRow.vala"
		_tmp2_ = self->priv->app;
#line 60 "../src/AppRow.vala"
		sound_pulse_audio_manager_change_application_volume (_tmp1_, _tmp2_, CLAMP (new_value, (gdouble) 0, (gdouble) 1));
#line 507 "AppRow.c"
	}
#line 63 "../src/AppRow.vala"
	result = TRUE;
#line 63 "../src/AppRow.vala"
	return result;
#line 513 "AppRow.c"
}

static gboolean
__sound_app_row___lambda18__gtk_range_change_value (GtkRange* _sender,
                                                    GtkScrollType scroll,
                                                    gdouble new_value,
                                                    gpointer self)
{
	gboolean result;
	result = _sound_app_row___lambda18_ ((SoundAppRow*) self, scroll, new_value);
#line 58 "../src/AppRow.vala"
	return result;
#line 526 "AppRow.c"
}

static void
_sound_app_row___lambda19_ (SoundAppRow* self)
{
#line 66 "../src/AppRow.vala"
	sound_app_row_toggle_mute_application (self, NULL);
#line 534 "AppRow.c"
}

static void
__sound_app_row___lambda19__gtk_button_clicked (GtkButton* _sender,
                                                gpointer self)
{
#line 66 "../src/AppRow.vala"
	_sound_app_row___lambda19_ ((SoundAppRow*) self);
#line 543 "AppRow.c"
}

static gboolean
_sound_app_row___lambda20_ (SoundAppRow* self,
                            gboolean state)
{
	gboolean _tmp0_;
	gboolean result;
#line 69 "../src/AppRow.vala"
	_tmp0_ = !state;
#line 69 "../src/AppRow.vala"
	sound_app_row_toggle_mute_application (self, &_tmp0_);
#line 70 "../src/AppRow.vala"
	result = TRUE;
#line 70 "../src/AppRow.vala"
	return result;
#line 560 "AppRow.c"
}

static gboolean
__sound_app_row___lambda20__gtk_switch_state_set (GtkSwitch* _sender,
                                                  gboolean state,
                                                  gpointer self)
{
	gboolean result;
	result = _sound_app_row___lambda20_ ((SoundAppRow*) self, state);
#line 68 "../src/AppRow.vala"
	return result;
#line 572 "AppRow.c"
}

static GObject *
sound_app_row_constructor (GType type,
                           guint n_construct_properties,
                           GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	SoundAppRow * self;
	GtkImage* _tmp0_ = NULL;
	GtkLabel* _tmp1_ = NULL;
	GtkLabel* _tmp2_;
	GtkLabel* _tmp3_ = NULL;
	GtkLabel* _tmp4_;
	GtkLabel* _tmp5_;
	GtkBox* label_box = NULL;
	GtkBox* _tmp6_;
	GtkBox* _tmp7_;
	GtkLabel* _tmp8_;
	GtkBox* _tmp9_;
	GtkLabel* _tmp10_;
	GtkButton* _tmp11_;
	GtkScale* _tmp12_ = NULL;
	GtkSwitch* _tmp13_ = NULL;
	GtkImage* _tmp14_;
	GtkBox* _tmp15_;
	GtkButton* _tmp16_;
	GtkScale* _tmp17_;
	GtkSwitch* _tmp18_;
	GtkScale* _tmp19_;
	GtkButton* _tmp20_;
	GtkSwitch* _tmp21_;
#line 17 "../src/AppRow.vala"
	parent_class = G_OBJECT_CLASS (sound_app_row_parent_class);
#line 17 "../src/AppRow.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 17 "../src/AppRow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SOUND_TYPE_APP_ROW, SoundAppRow);
#line 18 "../src/AppRow.vala"
	_tmp0_ = (GtkImage*) gtk_image_new ();
#line 18 "../src/AppRow.vala"
	gtk_image_set_icon_size (_tmp0_, GTK_ICON_SIZE_LARGE);
#line 18 "../src/AppRow.vala"
	g_object_ref_sink (_tmp0_);
#line 18 "../src/AppRow.vala"
	_g_object_unref0 (self->priv->image);
#line 18 "../src/AppRow.vala"
	self->priv->image = _tmp0_;
#line 22 "../src/AppRow.vala"
	_tmp1_ = (GtkLabel*) gtk_label_new ("");
#line 22 "../src/AppRow.vala"
	gtk_label_set_ellipsize (_tmp1_, PANGO_ELLIPSIZE_END);
#line 22 "../src/AppRow.vala"
	gtk_label_set_xalign (_tmp1_, (gfloat) 0);
#line 22 "../src/AppRow.vala"
	g_object_ref_sink (_tmp1_);
#line 22 "../src/AppRow.vala"
	_g_object_unref0 (self->priv->app_name_label);
#line 22 "../src/AppRow.vala"
	self->priv->app_name_label = _tmp1_;
#line 26 "../src/AppRow.vala"
	_tmp2_ = self->priv->app_name_label;
#line 26 "../src/AppRow.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp2_, GRANITE_STYLE_CLASS_H3_LABEL);
#line 28 "../src/AppRow.vala"
	_tmp3_ = (GtkLabel*) gtk_label_new ("");
#line 28 "../src/AppRow.vala"
	gtk_label_set_ellipsize (_tmp3_, PANGO_ELLIPSIZE_END);
#line 28 "../src/AppRow.vala"
	gtk_label_set_xalign (_tmp3_, (gfloat) 0);
#line 28 "../src/AppRow.vala"
	g_object_ref_sink (_tmp3_);
#line 28 "../src/AppRow.vala"
	_g_object_unref0 (self->priv->media_name_label);
#line 28 "../src/AppRow.vala"
	self->priv->media_name_label = _tmp3_;
#line 32 "../src/AppRow.vala"
	_tmp4_ = self->priv->media_name_label;
#line 32 "../src/AppRow.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp4_, GRANITE_STYLE_CLASS_DIM_LABEL);
#line 33 "../src/AppRow.vala"
	_tmp5_ = self->priv->media_name_label;
#line 33 "../src/AppRow.vala"
	gtk_widget_add_css_class ((GtkWidget*) _tmp5_, GRANITE_STYLE_CLASS_SMALL_LABEL);
#line 35 "../src/AppRow.vala"
	_tmp6_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_HORIZONTAL, 6);
#line 35 "../src/AppRow.vala"
	g_object_ref_sink (_tmp6_);
#line 35 "../src/AppRow.vala"
	label_box = _tmp6_;
#line 36 "../src/AppRow.vala"
	_tmp7_ = label_box;
#line 36 "../src/AppRow.vala"
	_tmp8_ = self->priv->app_name_label;
#line 36 "../src/AppRow.vala"
	gtk_box_append (_tmp7_, (GtkWidget*) _tmp8_);
#line 37 "../src/AppRow.vala"
	_tmp9_ = label_box;
#line 37 "../src/AppRow.vala"
	_tmp10_ = self->priv->media_name_label;
#line 37 "../src/AppRow.vala"
	gtk_box_append (_tmp9_, (GtkWidget*) _tmp10_);
#line 39 "../src/AppRow.vala"
	_tmp11_ = (GtkButton*) gtk_button_new_from_icon_name ("audio-volume-muted");
#line 39 "../src/AppRow.vala"
	g_object_ref_sink (_tmp11_);
#line 39 "../src/AppRow.vala"
	_g_object_unref0 (self->priv->icon_button);
#line 39 "../src/AppRow.vala"
	self->priv->icon_button = _tmp11_;
#line 41 "../src/AppRow.vala"
	_tmp12_ = (GtkScale*) gtk_scale_new_with_range (GTK_ORIENTATION_HORIZONTAL, (gdouble) 0, (gdouble) 1, 0.01);
#line 41 "../src/AppRow.vala"
	gtk_widget_set_hexpand ((GtkWidget*) _tmp12_, TRUE);
#line 41 "../src/AppRow.vala"
	g_object_ref_sink (_tmp12_);
#line 41 "../src/AppRow.vala"
	_g_object_unref0 (self->priv->volume_scale);
#line 41 "../src/AppRow.vala"
	self->priv->volume_scale = _tmp12_;
#line 45 "../src/AppRow.vala"
	_tmp13_ = (GtkSwitch*) gtk_switch_new ();
#line 45 "../src/AppRow.vala"
	gtk_widget_set_valign ((GtkWidget*) _tmp13_, GTK_ALIGN_CENTER);
#line 45 "../src/AppRow.vala"
	g_object_ref_sink (_tmp13_);
#line 45 "../src/AppRow.vala"
	_g_object_unref0 (self->priv->mute_switch);
#line 45 "../src/AppRow.vala"
	self->priv->mute_switch = _tmp13_;
#line 49 "../src/AppRow.vala"
	gtk_widget_set_hexpand ((GtkWidget*) self, TRUE);
#line 50 "../src/AppRow.vala"
	gtk_grid_set_column_spacing ((GtkGrid*) self, 6);
#line 52 "../src/AppRow.vala"
	_tmp14_ = self->priv->image;
#line 52 "../src/AppRow.vala"
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp14_, 0, 0, 1, 2);
#line 53 "../src/AppRow.vala"
	_tmp15_ = label_box;
#line 53 "../src/AppRow.vala"
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp15_, 1, 0, 2, 1);
#line 54 "../src/AppRow.vala"
	_tmp16_ = self->priv->icon_button;
#line 54 "../src/AppRow.vala"
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp16_, 1, 1, 1, 1);
#line 55 "../src/AppRow.vala"
	_tmp17_ = self->priv->volume_scale;
#line 55 "../src/AppRow.vala"
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp17_, 2, 1, 1, 1);
#line 56 "../src/AppRow.vala"
	_tmp18_ = self->priv->mute_switch;
#line 56 "../src/AppRow.vala"
	gtk_grid_attach ((GtkGrid*) self, (GtkWidget*) _tmp18_, 3, 0, 1, 2);
#line 58 "../src/AppRow.vala"
	_tmp19_ = self->priv->volume_scale;
#line 58 "../src/AppRow.vala"
	g_signal_connect_object ((GtkRange*) _tmp19_, "change-value", (GCallback) __sound_app_row___lambda18__gtk_range_change_value, self, 0);
#line 66 "../src/AppRow.vala"
	_tmp20_ = self->priv->icon_button;
#line 66 "../src/AppRow.vala"
	g_signal_connect_object (_tmp20_, "clicked", (GCallback) __sound_app_row___lambda19__gtk_button_clicked, self, 0);
#line 68 "../src/AppRow.vala"
	_tmp21_ = self->priv->mute_switch;
#line 68 "../src/AppRow.vala"
	g_signal_connect_object (_tmp21_, "state-set", (GCallback) __sound_app_row___lambda20__gtk_switch_state_set, self, 0);
#line 17 "../src/AppRow.vala"
	_g_object_unref0 (label_box);
#line 17 "../src/AppRow.vala"
	return obj;
#line 744 "AppRow.c"
}

static void
sound_app_row_class_init (SoundAppRowClass * klass,
                          gpointer klass_data)
{
#line 8 "../src/AppRow.vala"
	sound_app_row_parent_class = g_type_class_peek_parent (klass);
#line 8 "../src/AppRow.vala"
	g_type_class_adjust_private_offset (klass, &SoundAppRow_private_offset);
#line 8 "../src/AppRow.vala"
	G_OBJECT_CLASS (klass)->constructor = sound_app_row_constructor;
#line 8 "../src/AppRow.vala"
	G_OBJECT_CLASS (klass)->finalize = sound_app_row_finalize;
#line 759 "AppRow.c"
}

static void
sound_app_row_instance_init (SoundAppRow * self,
                             gpointer klass)
{
#line 8 "../src/AppRow.vala"
	self->priv = sound_app_row_get_instance_private (self);
#line 768 "AppRow.c"
}

static void
sound_app_row_finalize (GObject * obj)
{
	SoundAppRow * self;
#line 8 "../src/AppRow.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SOUND_TYPE_APP_ROW, SoundAppRow);
#line 9 "../src/AppRow.vala"
	_g_object_unref0 (self->priv->app);
#line 10 "../src/AppRow.vala"
	_g_object_unref0 (self->priv->app_name_label);
#line 11 "../src/AppRow.vala"
	_g_object_unref0 (self->priv->media_name_label);
#line 12 "../src/AppRow.vala"
	_g_object_unref0 (self->priv->image);
#line 13 "../src/AppRow.vala"
	_g_object_unref0 (self->priv->icon_button);
#line 14 "../src/AppRow.vala"
	_g_object_unref0 (self->priv->volume_scale);
#line 15 "../src/AppRow.vala"
	_g_object_unref0 (self->priv->mute_switch);
#line 8 "../src/AppRow.vala"
	G_OBJECT_CLASS (sound_app_row_parent_class)->finalize (obj);
#line 793 "AppRow.c"
}

static GType
sound_app_row_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SoundAppRowClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sound_app_row_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SoundAppRow), 0, (GInstanceInitFunc) sound_app_row_instance_init, NULL };
	GType sound_app_row_type_id;
	sound_app_row_type_id = g_type_register_static (gtk_grid_get_type (), "SoundAppRow", &g_define_type_info, 0);
	SoundAppRow_private_offset = g_type_add_instance_private (sound_app_row_type_id, sizeof (SoundAppRowPrivate));
	return sound_app_row_type_id;
}

GType
sound_app_row_get_type (void)
{
	static volatile gsize sound_app_row_type_id__once = 0;
	if (g_once_init_enter (&sound_app_row_type_id__once)) {
		GType sound_app_row_type_id;
		sound_app_row_type_id = sound_app_row_get_type_once ();
		g_once_init_leave (&sound_app_row_type_id__once, sound_app_row_type_id);
	}
	return sound_app_row_type_id__once;
}

