/* Plug.c generated by valac 0.56.17, the Vala compiler
 * generated from Plug.vala, do not modify */

/*
 * SPDX-License-Identifier: LGPL-2.0-or-later
 * SPDX-FileCopyrightText: 2016-2023 elementary, Inc. (https://elementary.io)
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include "io.elementary.settings.sound.h"
#include <gtk/gtk.h>
#include <switchboard.h>
#include <stdlib.h>
#include <string.h>
#include <glib.h>
#include <gio/gio.h>
#include <gee.h>
#include <glib-object.h>
#include <glib/gi18n-lib.h>
#include <adwaita.h>
#include <granite-7.h>
#include <gmodule.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	SOUND_PLUG_0_PROPERTY,
	SOUND_PLUG_NUM_PROPERTIES
};
static GParamSpec* sound_plug_properties[SOUND_PLUG_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))
typedef struct _SoundPlugSearchData SoundPlugSearchData;

struct _SoundPlugPrivate {
	GtkBox* box;
	GtkStack* stack;
	SoundInputPanel* input_panel;
};

struct _SoundPlugSearchData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	SoundPlug* self;
	gchar* search;
	GeeTreeMap* result;
	GeeTreeMap* search_results;
	GeeTreeMap* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	const gchar* _tmp9_;
	const gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* _tmp12_;
	const gchar* _tmp13_;
	const gchar* _tmp14_;
	gchar* _tmp15_;
	gchar* _tmp16_;
	const gchar* _tmp17_;
	const gchar* _tmp18_;
	gchar* _tmp19_;
	gchar* _tmp20_;
	const gchar* _tmp21_;
	const gchar* _tmp22_;
	gchar* _tmp23_;
	gchar* _tmp24_;
	const gchar* _tmp25_;
	const gchar* _tmp26_;
	gchar* _tmp27_;
	gchar* _tmp28_;
	const gchar* _tmp29_;
	const gchar* _tmp30_;
	gchar* _tmp31_;
	gchar* _tmp32_;
	const gchar* _tmp33_;
	const gchar* _tmp34_;
	gchar* _tmp35_;
	gchar* _tmp36_;
	const gchar* _tmp37_;
	const gchar* _tmp38_;
	gchar* _tmp39_;
	gchar* _tmp40_;
	const gchar* _tmp41_;
	const gchar* _tmp42_;
	gchar* _tmp43_;
	gchar* _tmp44_;
	const gchar* _tmp45_;
	const gchar* _tmp46_;
	gchar* _tmp47_;
	gchar* _tmp48_;
	const gchar* _tmp49_;
	const gchar* _tmp50_;
	gchar* _tmp51_;
	gchar* _tmp52_;
	const gchar* _tmp53_;
	const gchar* _tmp54_;
	gchar* _tmp55_;
	gchar* _tmp56_;
};

static gint SoundPlug_private_offset;
static gpointer sound_plug_parent_class = NULL;

static GtkWidget* sound_plug_real_get_widget (SwitchboardPlug* base);
static void ___lambda39_ (SoundPlug* self);
static void ____lambda39__g_object_notify (GObject* _sender,
                                    GParamSpec* pspec,
                                    gpointer self);
static void sound_plug_real_shown (SwitchboardPlug* base);
static void sound_plug_real_hidden (SwitchboardPlug* base);
static void sound_plug_real_search_callback (SwitchboardPlug* base,
                                      const gchar* location);
static void sound_plug_real_search_data_free (gpointer _data);
static void sound_plug_real_search (SwitchboardPlug* base,
                             const gchar* search,
                             GAsyncReadyCallback _callback_,
                             gpointer _user_data_);
static gboolean sound_plug_real_search_co (SoundPlugSearchData* _data_);
static void sound_plug_finalize (GObject * obj);
static GType sound_plug_get_type_once (void);
static inline gpointer _vala_memdup2 (gconstpointer mem,
                        gsize byte_size);

static inline gpointer
sound_plug_get_instance_private (SoundPlug* self)
{
	return G_STRUCT_MEMBER_P (self, SoundPlug_private_offset);
}

SoundPlug*
sound_plug_construct (GType object_type)
{
	SoundPlug * self = NULL;
	GeeTreeMap* settings = NULL;
	GeeTreeMap* _tmp0_;
#line 14 "../src/Plug.vala"
	bindtextdomain (GETTEXT_PACKAGE, LOCALEDIR);
#line 15 "../src/Plug.vala"
	bind_textdomain_codeset (GETTEXT_PACKAGE, "UTF-8");
#line 17 "../src/Plug.vala"
	_tmp0_ = gee_tree_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL);
#line 17 "../src/Plug.vala"
	settings = _tmp0_;
#line 18 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) settings, "sound", NULL);
#line 19 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) settings, "sound/applications", "applications");
#line 20 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) settings, "sound/input", "input");
#line 21 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) settings, "sound/output", "output");
#line 22 "../src/Plug.vala"
	self = (SoundPlug*) g_object_new (object_type, "category", SWITCHBOARD_PLUG_CATEGORY_HARDWARE, "code-name", "io.elementary.settings.sound", "display-name", _ ("Sound"), "description", _ ("Change sound and microphone volume"), "icon", "preferences-desktop-sound", "supported-settings", settings, NULL);
#line 13 "../src/Plug.vala"
	_g_object_unref0 (settings);
#line 13 "../src/Plug.vala"
	return self;
#line 175 "Plug.c"
}

SoundPlug*
sound_plug_new (void)
{
#line 13 "../src/Plug.vala"
	return sound_plug_construct (SOUND_TYPE_PLUG);
#line 183 "Plug.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 47 "../src/Plug.vala"
	return self ? g_object_ref (self) : NULL;
#line 191 "Plug.c"
}

static void
___lambda39_ (SoundPlug* self)
{
	SoundInputPanel* _tmp0_;
	GtkStack* _tmp1_;
	GtkWidget* _tmp2_;
	GtkWidget* _tmp3_;
	SoundInputPanel* _tmp4_;
#line 70 "../src/Plug.vala"
	_tmp0_ = self->priv->input_panel;
#line 70 "../src/Plug.vala"
	_tmp1_ = self->priv->stack;
#line 70 "../src/Plug.vala"
	_tmp2_ = gtk_stack_get_visible_child (_tmp1_);
#line 70 "../src/Plug.vala"
	_tmp3_ = _tmp2_;
#line 70 "../src/Plug.vala"
	_tmp4_ = self->priv->input_panel;
#line 70 "../src/Plug.vala"
	sound_input_panel_set_visibility (_tmp0_, _tmp3_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, gtk_widget_get_type (), GtkWidget));
#line 214 "Plug.c"
}

static void
____lambda39__g_object_notify (GObject* _sender,
                               GParamSpec* pspec,
                               gpointer self)
{
#line 69 "../src/Plug.vala"
	___lambda39_ ((SoundPlug*) self);
#line 224 "Plug.c"
}

static GtkWidget*
sound_plug_real_get_widget (SwitchboardPlug* base)
{
	SoundPlug * self;
	GtkBox* _tmp0_;
	GtkBox* _tmp33_;
	GtkWidget* _tmp34_;
	GtkWidget* result;
#line 30 "../src/Plug.vala"
	self = (SoundPlug*) base;
#line 31 "../src/Plug.vala"
	_tmp0_ = self->priv->box;
#line 31 "../src/Plug.vala"
	if (_tmp0_ == NULL) {
#line 241 "Plug.c"
		SoundOutputPanel* output_panel = NULL;
		SoundOutputPanel* _tmp1_;
		SoundInputPanel* _tmp2_;
		SoundApplicationsPanel* applications_panel = NULL;
		SoundApplicationsPanel* _tmp3_;
		GtkStack* _tmp4_ = NULL;
		GtkStack* _tmp5_;
		SoundOutputPanel* _tmp6_;
		GtkStack* _tmp7_;
		SoundInputPanel* _tmp8_;
		GtkStack* _tmp9_;
		SoundApplicationsPanel* _tmp10_;
		GtkStackSwitcher* stack_switcher = NULL;
		GtkStack* _tmp11_;
		GtkStack* _tmp12_;
		GtkStackSwitcher* _tmp13_ = NULL;
		GtkStackSwitcher* _tmp14_;
		GtkLayoutManager* _tmp15_;
		GtkLayoutManager* _tmp16_;
		AdwClamp* clamp = NULL;
		GtkStack* _tmp17_;
		GtkWidget* _tmp18_;
		AdwClamp* _tmp19_ = NULL;
		AdwHeaderBar* headerbar = NULL;
		GtkStackSwitcher* _tmp20_;
		GtkWidget* _tmp21_;
		AdwHeaderBar* _tmp22_ = NULL;
		AdwHeaderBar* _tmp23_;
		GtkBox* _tmp24_;
		GtkBox* _tmp25_;
		AdwHeaderBar* _tmp26_;
		GtkBox* _tmp27_;
		AdwClamp* _tmp28_;
		SoundPulseAudioManager* pam = NULL;
		SoundPulseAudioManager* _tmp29_;
		SoundPulseAudioManager* _tmp30_;
		SoundPulseAudioManager* _tmp31_;
		GtkStack* _tmp32_;
#line 32 "../src/Plug.vala"
		_tmp1_ = sound_output_panel_new ();
#line 32 "../src/Plug.vala"
		g_object_ref_sink (_tmp1_);
#line 32 "../src/Plug.vala"
		output_panel = _tmp1_;
#line 33 "../src/Plug.vala"
		_tmp2_ = sound_input_panel_new ();
#line 33 "../src/Plug.vala"
		g_object_ref_sink (_tmp2_);
#line 33 "../src/Plug.vala"
		_g_object_unref0 (self->priv->input_panel);
#line 33 "../src/Plug.vala"
		self->priv->input_panel = _tmp2_;
#line 34 "../src/Plug.vala"
		_tmp3_ = sound_applications_panel_new ();
#line 34 "../src/Plug.vala"
		g_object_ref_sink (_tmp3_);
#line 34 "../src/Plug.vala"
		applications_panel = _tmp3_;
#line 36 "../src/Plug.vala"
		_tmp4_ = (GtkStack*) gtk_stack_new ();
#line 36 "../src/Plug.vala"
		gtk_widget_set_hexpand ((GtkWidget*) _tmp4_, TRUE);
#line 36 "../src/Plug.vala"
		gtk_widget_set_vexpand ((GtkWidget*) _tmp4_, TRUE);
#line 36 "../src/Plug.vala"
		gtk_widget_set_margin_start ((GtkWidget*) _tmp4_, 12);
#line 36 "../src/Plug.vala"
		gtk_widget_set_margin_end ((GtkWidget*) _tmp4_, 12);
#line 36 "../src/Plug.vala"
		gtk_widget_set_margin_bottom ((GtkWidget*) _tmp4_, 12);
#line 36 "../src/Plug.vala"
		g_object_ref_sink (_tmp4_);
#line 36 "../src/Plug.vala"
		_g_object_unref0 (self->priv->stack);
#line 36 "../src/Plug.vala"
		self->priv->stack = _tmp4_;
#line 43 "../src/Plug.vala"
		_tmp5_ = self->priv->stack;
#line 43 "../src/Plug.vala"
		_tmp6_ = output_panel;
#line 43 "../src/Plug.vala"
		gtk_stack_add_titled (_tmp5_, (GtkWidget*) _tmp6_, "output", _ ("Output"));
#line 44 "../src/Plug.vala"
		_tmp7_ = self->priv->stack;
#line 44 "../src/Plug.vala"
		_tmp8_ = self->priv->input_panel;
#line 44 "../src/Plug.vala"
		gtk_stack_add_titled (_tmp7_, (GtkWidget*) _tmp8_, "input", _ ("Input"));
#line 45 "../src/Plug.vala"
		_tmp9_ = self->priv->stack;
#line 45 "../src/Plug.vala"
		_tmp10_ = applications_panel;
#line 45 "../src/Plug.vala"
		gtk_stack_add_titled (_tmp9_, (GtkWidget*) _tmp10_, "applications", _ ("Applications"));
#line 47 "../src/Plug.vala"
		_tmp11_ = self->priv->stack;
#line 47 "../src/Plug.vala"
		_tmp12_ = _g_object_ref0 (_tmp11_);
#line 47 "../src/Plug.vala"
		_tmp13_ = (GtkStackSwitcher*) gtk_stack_switcher_new ();
#line 47 "../src/Plug.vala"
		gtk_widget_set_halign ((GtkWidget*) _tmp13_, GTK_ALIGN_CENTER);
#line 47 "../src/Plug.vala"
		gtk_stack_switcher_set_stack (_tmp13_, _tmp12_);
#line 47 "../src/Plug.vala"
		_g_object_unref0 (_tmp12_);
#line 47 "../src/Plug.vala"
		g_object_ref_sink (_tmp13_);
#line 47 "../src/Plug.vala"
		stack_switcher = _tmp13_;
#line 51 "../src/Plug.vala"
		_tmp14_ = stack_switcher;
#line 51 "../src/Plug.vala"
		_tmp15_ = gtk_widget_get_layout_manager ((GtkWidget*) _tmp14_);
#line 51 "../src/Plug.vala"
		_tmp16_ = _tmp15_;
#line 51 "../src/Plug.vala"
		gtk_box_layout_set_homogeneous (G_TYPE_CHECK_INSTANCE_CAST (_tmp16_, gtk_box_layout_get_type (), GtkBoxLayout), TRUE);
#line 53 "../src/Plug.vala"
		_tmp17_ = self->priv->stack;
#line 53 "../src/Plug.vala"
		_tmp18_ = _g_object_ref0 ((GtkWidget*) _tmp17_);
#line 53 "../src/Plug.vala"
		_tmp19_ = (AdwClamp*) adw_clamp_new ();
#line 53 "../src/Plug.vala"
		adw_clamp_set_child (_tmp19_, _tmp18_);
#line 53 "../src/Plug.vala"
		_g_object_unref0 (_tmp18_);
#line 53 "../src/Plug.vala"
		g_object_ref_sink (_tmp19_);
#line 53 "../src/Plug.vala"
		clamp = _tmp19_;
#line 57 "../src/Plug.vala"
		_tmp20_ = stack_switcher;
#line 57 "../src/Plug.vala"
		_tmp21_ = _g_object_ref0 ((GtkWidget*) _tmp20_);
#line 57 "../src/Plug.vala"
		_tmp22_ = (AdwHeaderBar*) adw_header_bar_new ();
#line 57 "../src/Plug.vala"
		adw_header_bar_set_title_widget (_tmp22_, _tmp21_);
#line 57 "../src/Plug.vala"
		_g_object_unref0 (_tmp21_);
#line 57 "../src/Plug.vala"
		g_object_ref_sink (_tmp22_);
#line 57 "../src/Plug.vala"
		headerbar = _tmp22_;
#line 60 "../src/Plug.vala"
		_tmp23_ = headerbar;
#line 60 "../src/Plug.vala"
		gtk_widget_add_css_class ((GtkWidget*) _tmp23_, GRANITE_STYLE_CLASS_FLAT);
#line 62 "../src/Plug.vala"
		_tmp24_ = (GtkBox*) gtk_box_new (GTK_ORIENTATION_VERTICAL, 0);
#line 62 "../src/Plug.vala"
		g_object_ref_sink (_tmp24_);
#line 62 "../src/Plug.vala"
		_g_object_unref0 (self->priv->box);
#line 62 "../src/Plug.vala"
		self->priv->box = _tmp24_;
#line 63 "../src/Plug.vala"
		_tmp25_ = self->priv->box;
#line 63 "../src/Plug.vala"
		_tmp26_ = headerbar;
#line 63 "../src/Plug.vala"
		gtk_box_append (_tmp25_, (GtkWidget*) _tmp26_);
#line 64 "../src/Plug.vala"
		_tmp27_ = self->priv->box;
#line 64 "../src/Plug.vala"
		_tmp28_ = clamp;
#line 64 "../src/Plug.vala"
		gtk_box_append (_tmp27_, (GtkWidget*) _tmp28_);
#line 66 "../src/Plug.vala"
		_tmp29_ = sound_pulse_audio_manager_get_default ();
#line 66 "../src/Plug.vala"
		_tmp30_ = _g_object_ref0 (_tmp29_);
#line 66 "../src/Plug.vala"
		pam = _tmp30_;
#line 67 "../src/Plug.vala"
		_tmp31_ = pam;
#line 67 "../src/Plug.vala"
		sound_pulse_audio_manager_start (_tmp31_);
#line 69 "../src/Plug.vala"
		_tmp32_ = self->priv->stack;
#line 69 "../src/Plug.vala"
		g_signal_connect_object ((GObject*) _tmp32_, "notify::visible-child", (GCallback) ____lambda39__g_object_notify, self, 0);
#line 31 "../src/Plug.vala"
		_g_object_unref0 (pam);
#line 31 "../src/Plug.vala"
		_g_object_unref0 (headerbar);
#line 31 "../src/Plug.vala"
		_g_object_unref0 (clamp);
#line 31 "../src/Plug.vala"
		_g_object_unref0 (stack_switcher);
#line 31 "../src/Plug.vala"
		_g_object_unref0 (applications_panel);
#line 31 "../src/Plug.vala"
		_g_object_unref0 (output_panel);
#line 438 "Plug.c"
	}
#line 74 "../src/Plug.vala"
	_tmp33_ = self->priv->box;
#line 74 "../src/Plug.vala"
	_tmp34_ = _g_object_ref0 ((GtkWidget*) _tmp33_);
#line 74 "../src/Plug.vala"
	result = _tmp34_;
#line 74 "../src/Plug.vala"
	return result;
#line 448 "Plug.c"
}

static void
sound_plug_real_shown (SwitchboardPlug* base)
{
	SoundPlug * self;
	GtkBox* _tmp0_;
	GtkStack* _tmp1_;
	GtkWidget* _tmp2_;
	GtkWidget* _tmp3_;
	SoundInputPanel* _tmp4_;
#line 77 "../src/Plug.vala"
	self = (SoundPlug*) base;
#line 78 "../src/Plug.vala"
	_tmp0_ = self->priv->box;
#line 78 "../src/Plug.vala"
	gtk_widget_show ((GtkWidget*) _tmp0_);
#line 79 "../src/Plug.vala"
	_tmp1_ = self->priv->stack;
#line 79 "../src/Plug.vala"
	_tmp2_ = gtk_stack_get_visible_child (_tmp1_);
#line 79 "../src/Plug.vala"
	_tmp3_ = _tmp2_;
#line 79 "../src/Plug.vala"
	_tmp4_ = self->priv->input_panel;
#line 79 "../src/Plug.vala"
	if (_tmp3_ == G_TYPE_CHECK_INSTANCE_CAST (_tmp4_, gtk_widget_get_type (), GtkWidget)) {
#line 476 "Plug.c"
		SoundInputPanel* _tmp5_;
#line 80 "../src/Plug.vala"
		_tmp5_ = self->priv->input_panel;
#line 80 "../src/Plug.vala"
		sound_input_panel_set_visibility (_tmp5_, TRUE);
#line 482 "Plug.c"
	}
}

static void
sound_plug_real_hidden (SwitchboardPlug* base)
{
	SoundPlug * self;
#line 84 "../src/Plug.vala"
	self = (SoundPlug*) base;
#line 492 "Plug.c"
}

static void
sound_plug_real_search_callback (SwitchboardPlug* base,
                                 const gchar* location)
{
	SoundPlug * self;
	GtkStack* _tmp0_;
#line 87 "../src/Plug.vala"
	self = (SoundPlug*) base;
#line 87 "../src/Plug.vala"
	g_return_if_fail (location != NULL);
#line 88 "../src/Plug.vala"
	_tmp0_ = self->priv->stack;
#line 88 "../src/Plug.vala"
	gtk_stack_set_visible_child_name (_tmp0_, location);
#line 509 "Plug.c"
}

static void
sound_plug_real_search_data_free (gpointer _data)
{
	SoundPlugSearchData* _data_;
	_data_ = _data;
#line 8 "../src/Plug.vala"
	_g_free0 (_data_->search);
#line 8 "../src/Plug.vala"
	_g_object_unref0 (_data_->result);
#line 8 "../src/Plug.vala"
	_g_object_unref0 (_data_->self);
#line 8 "../src/Plug.vala"
	g_slice_free (SoundPlugSearchData, _data_);
#line 525 "Plug.c"
}

static void
sound_plug_real_search (SwitchboardPlug* base,
                        const gchar* search,
                        GAsyncReadyCallback _callback_,
                        gpointer _user_data_)
{
	SoundPlug * self;
	SoundPlugSearchData* _data_;
	SoundPlug* _tmp0_;
	gchar* _tmp1_;
#line 8 "../src/Plug.vala"
	g_return_if_fail (search != NULL);
#line 8 "../src/Plug.vala"
	self = (SoundPlug*) base;
#line 8 "../src/Plug.vala"
	_data_ = g_slice_new0 (SoundPlugSearchData);
#line 8 "../src/Plug.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), NULL, _callback_, _user_data_);
#line 8 "../src/Plug.vala"
	g_task_set_task_data (_data_->_async_result, _data_, sound_plug_real_search_data_free);
#line 8 "../src/Plug.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 8 "../src/Plug.vala"
	_data_->self = _tmp0_;
#line 8 "../src/Plug.vala"
	_tmp1_ = g_strdup (search);
#line 8 "../src/Plug.vala"
	_g_free0 (_data_->search);
#line 8 "../src/Plug.vala"
	_data_->search = _tmp1_;
#line 8 "../src/Plug.vala"
	sound_plug_real_search_co (_data_);
#line 560 "Plug.c"
}

static GeeTreeMap*
sound_plug_search_finish (SwitchboardPlug* base,
                          GAsyncResult* _res_)
{
	GeeTreeMap* result;
	SoundPlugSearchData* _data_;
#line 8 "../src/Plug.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 8 "../src/Plug.vala"
	result = _data_->result;
#line 8 "../src/Plug.vala"
	_data_->result = NULL;
#line 8 "../src/Plug.vala"
	return result;
#line 577 "Plug.c"
}

static gboolean
sound_plug_real_search_co (SoundPlugSearchData* _data_)
{
#line 92 "../src/Plug.vala"
	switch (_data_->_state_) {
#line 92 "../src/Plug.vala"
		case 0:
#line 587 "Plug.c"
		goto _state_0;
		default:
#line 92 "../src/Plug.vala"
		g_assert_not_reached ();
#line 592 "Plug.c"
	}
	_state_0:
#line 93 "../src/Plug.vala"
	_data_->_tmp0_ = gee_tree_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL, NULL, NULL, NULL);
#line 93 "../src/Plug.vala"
	_data_->search_results = _data_->_tmp0_;
#line 94 "../src/Plug.vala"
	_data_->_tmp1_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
#line 94 "../src/Plug.vala"
	_data_->_tmp2_ = _data_->_tmp1_;
#line 94 "../src/Plug.vala"
	_data_->_tmp3_ = g_strdup_printf ("%s → %s", _data_->_tmp2_, _ ("Output"));
#line 94 "../src/Plug.vala"
	_data_->_tmp4_ = _data_->_tmp3_;
#line 94 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _data_->search_results, _data_->_tmp4_, "output");
#line 94 "../src/Plug.vala"
	_g_free0 (_data_->_tmp4_);
#line 95 "../src/Plug.vala"
	_data_->_tmp5_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
#line 95 "../src/Plug.vala"
	_data_->_tmp6_ = _data_->_tmp5_;
#line 95 "../src/Plug.vala"
	_data_->_tmp7_ = g_strdup_printf ("%s → %s → %s", _data_->_tmp6_, _ ("Output"), _ ("Device"));
#line 95 "../src/Plug.vala"
	_data_->_tmp8_ = _data_->_tmp7_;
#line 95 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _data_->search_results, _data_->_tmp8_, "output");
#line 95 "../src/Plug.vala"
	_g_free0 (_data_->_tmp8_);
#line 96 "../src/Plug.vala"
	_data_->_tmp9_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
#line 96 "../src/Plug.vala"
	_data_->_tmp10_ = _data_->_tmp9_;
#line 96 "../src/Plug.vala"
	_data_->_tmp11_ = g_strdup_printf ("%s → %s → %s", _data_->_tmp10_, _ ("Output"), _ ("Event Alerts"));
#line 96 "../src/Plug.vala"
	_data_->_tmp12_ = _data_->_tmp11_;
#line 96 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _data_->search_results, _data_->_tmp12_, "output");
#line 96 "../src/Plug.vala"
	_g_free0 (_data_->_tmp12_);
#line 97 "../src/Plug.vala"
	_data_->_tmp13_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
#line 97 "../src/Plug.vala"
	_data_->_tmp14_ = _data_->_tmp13_;
#line 97 "../src/Plug.vala"
	_data_->_tmp15_ = g_strdup_printf ("%s → %s → %s", _data_->_tmp14_, _ ("Output"), _ ("Port"));
#line 97 "../src/Plug.vala"
	_data_->_tmp16_ = _data_->_tmp15_;
#line 97 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _data_->search_results, _data_->_tmp16_, "output");
#line 97 "../src/Plug.vala"
	_g_free0 (_data_->_tmp16_);
#line 98 "../src/Plug.vala"
	_data_->_tmp17_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
#line 98 "../src/Plug.vala"
	_data_->_tmp18_ = _data_->_tmp17_;
#line 98 "../src/Plug.vala"
	_data_->_tmp19_ = g_strdup_printf ("%s → %s → %s", _data_->_tmp18_, _ ("Output"), _ ("Volume"));
#line 98 "../src/Plug.vala"
	_data_->_tmp20_ = _data_->_tmp19_;
#line 98 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _data_->search_results, _data_->_tmp20_, "output");
#line 98 "../src/Plug.vala"
	_g_free0 (_data_->_tmp20_);
#line 99 "../src/Plug.vala"
	_data_->_tmp21_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
#line 99 "../src/Plug.vala"
	_data_->_tmp22_ = _data_->_tmp21_;
#line 99 "../src/Plug.vala"
	_data_->_tmp23_ = g_strdup_printf ("%s → %s → %s", _data_->_tmp22_, _ ("Output"), _ ("Balance"));
#line 99 "../src/Plug.vala"
	_data_->_tmp24_ = _data_->_tmp23_;
#line 99 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _data_->search_results, _data_->_tmp24_, "output");
#line 99 "../src/Plug.vala"
	_g_free0 (_data_->_tmp24_);
#line 100 "../src/Plug.vala"
	_data_->_tmp25_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
#line 100 "../src/Plug.vala"
	_data_->_tmp26_ = _data_->_tmp25_;
#line 100 "../src/Plug.vala"
	_data_->_tmp27_ = g_strdup_printf ("%s → %s → %s", _data_->_tmp26_, _ ("Output"), _ ("Screen Reader"));
#line 100 "../src/Plug.vala"
	_data_->_tmp28_ = _data_->_tmp27_;
#line 100 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _data_->search_results, _data_->_tmp28_, "output");
#line 100 "../src/Plug.vala"
	_g_free0 (_data_->_tmp28_);
#line 101 "../src/Plug.vala"
	_data_->_tmp29_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
#line 101 "../src/Plug.vala"
	_data_->_tmp30_ = _data_->_tmp29_;
#line 101 "../src/Plug.vala"
	_data_->_tmp31_ = g_strdup_printf ("%s → %s → %s", _data_->_tmp30_, _ ("Output"), _ ("Test Speakers"));
#line 101 "../src/Plug.vala"
	_data_->_tmp32_ = _data_->_tmp31_;
#line 101 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _data_->search_results, _data_->_tmp32_, "output");
#line 101 "../src/Plug.vala"
	_g_free0 (_data_->_tmp32_);
#line 102 "../src/Plug.vala"
	_data_->_tmp33_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
#line 102 "../src/Plug.vala"
	_data_->_tmp34_ = _data_->_tmp33_;
#line 102 "../src/Plug.vala"
	_data_->_tmp35_ = g_strdup_printf ("%s → %s", _data_->_tmp34_, _ ("Input"));
#line 102 "../src/Plug.vala"
	_data_->_tmp36_ = _data_->_tmp35_;
#line 102 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _data_->search_results, _data_->_tmp36_, "input");
#line 102 "../src/Plug.vala"
	_g_free0 (_data_->_tmp36_);
#line 103 "../src/Plug.vala"
	_data_->_tmp37_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
#line 103 "../src/Plug.vala"
	_data_->_tmp38_ = _data_->_tmp37_;
#line 103 "../src/Plug.vala"
	_data_->_tmp39_ = g_strdup_printf ("%s → %s → %s", _data_->_tmp38_, _ ("Input"), _ ("Device"));
#line 103 "../src/Plug.vala"
	_data_->_tmp40_ = _data_->_tmp39_;
#line 103 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _data_->search_results, _data_->_tmp40_, "input");
#line 103 "../src/Plug.vala"
	_g_free0 (_data_->_tmp40_);
#line 104 "../src/Plug.vala"
	_data_->_tmp41_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
#line 104 "../src/Plug.vala"
	_data_->_tmp42_ = _data_->_tmp41_;
#line 104 "../src/Plug.vala"
	_data_->_tmp43_ = g_strdup_printf ("%s → %s → %s", _data_->_tmp42_, _ ("Input"), _ ("Port"));
#line 104 "../src/Plug.vala"
	_data_->_tmp44_ = _data_->_tmp43_;
#line 104 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _data_->search_results, _data_->_tmp44_, "input");
#line 104 "../src/Plug.vala"
	_g_free0 (_data_->_tmp44_);
#line 105 "../src/Plug.vala"
	_data_->_tmp45_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
#line 105 "../src/Plug.vala"
	_data_->_tmp46_ = _data_->_tmp45_;
#line 105 "../src/Plug.vala"
	_data_->_tmp47_ = g_strdup_printf ("%s → %s → %s", _data_->_tmp46_, _ ("Input"), _ ("Volume"));
#line 105 "../src/Plug.vala"
	_data_->_tmp48_ = _data_->_tmp47_;
#line 105 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _data_->search_results, _data_->_tmp48_, "input");
#line 105 "../src/Plug.vala"
	_g_free0 (_data_->_tmp48_);
#line 106 "../src/Plug.vala"
	_data_->_tmp49_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
#line 106 "../src/Plug.vala"
	_data_->_tmp50_ = _data_->_tmp49_;
#line 106 "../src/Plug.vala"
	_data_->_tmp51_ = g_strdup_printf ("%s → %s → %s", _data_->_tmp50_, _ ("Input"), _ ("Enable"));
#line 106 "../src/Plug.vala"
	_data_->_tmp52_ = _data_->_tmp51_;
#line 106 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _data_->search_results, _data_->_tmp52_, "input");
#line 106 "../src/Plug.vala"
	_g_free0 (_data_->_tmp52_);
#line 107 "../src/Plug.vala"
	_data_->_tmp53_ = switchboard_plug_get_display_name ((SwitchboardPlug*) _data_->self);
#line 107 "../src/Plug.vala"
	_data_->_tmp54_ = _data_->_tmp53_;
#line 107 "../src/Plug.vala"
	_data_->_tmp55_ = g_strdup_printf ("%s → %s", _data_->_tmp54_, _ ("Applications"));
#line 107 "../src/Plug.vala"
	_data_->_tmp56_ = _data_->_tmp55_;
#line 107 "../src/Plug.vala"
	gee_abstract_map_set ((GeeAbstractMap*) _data_->search_results, _data_->_tmp56_, "applications");
#line 107 "../src/Plug.vala"
	_g_free0 (_data_->_tmp56_);
#line 108 "../src/Plug.vala"
	_data_->result = _data_->search_results;
#line 108 "../src/Plug.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 108 "../src/Plug.vala"
	if (_data_->_state_ != 0) {
#line 108 "../src/Plug.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 108 "../src/Plug.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 777 "Plug.c"
		}
	}
#line 108 "../src/Plug.vala"
	g_object_unref (_data_->_async_result);
#line 108 "../src/Plug.vala"
	return FALSE;
#line 784 "Plug.c"
}

static void
sound_plug_class_init (SoundPlugClass * klass,
                       gpointer klass_data)
{
#line 8 "../src/Plug.vala"
	sound_plug_parent_class = g_type_class_peek_parent (klass);
#line 8 "../src/Plug.vala"
	g_type_class_adjust_private_offset (klass, &SoundPlug_private_offset);
#line 8 "../src/Plug.vala"
	((SwitchboardPlugClass *) klass)->get_widget = (GtkWidget* (*) (SwitchboardPlug*)) sound_plug_real_get_widget;
#line 8 "../src/Plug.vala"
	((SwitchboardPlugClass *) klass)->shown = (void (*) (SwitchboardPlug*)) sound_plug_real_shown;
#line 8 "../src/Plug.vala"
	((SwitchboardPlugClass *) klass)->hidden = (void (*) (SwitchboardPlug*)) sound_plug_real_hidden;
#line 8 "../src/Plug.vala"
	((SwitchboardPlugClass *) klass)->search_callback = (void (*) (SwitchboardPlug*, const gchar*)) sound_plug_real_search_callback;
#line 8 "../src/Plug.vala"
	((SwitchboardPlugClass *) klass)->search = (void (*) (SwitchboardPlug*, const gchar*, GAsyncReadyCallback, gpointer)) sound_plug_real_search;
#line 8 "../src/Plug.vala"
	((SwitchboardPlugClass *) klass)->search_finish = (GeeTreeMap* (*) (SwitchboardPlug*, GAsyncResult*)) sound_plug_search_finish;
#line 8 "../src/Plug.vala"
	G_OBJECT_CLASS (klass)->finalize = sound_plug_finalize;
#line 809 "Plug.c"
}

static void
sound_plug_instance_init (SoundPlug * self,
                          gpointer klass)
{
#line 8 "../src/Plug.vala"
	self->priv = sound_plug_get_instance_private (self);
#line 818 "Plug.c"
}

static void
sound_plug_finalize (GObject * obj)
{
	SoundPlug * self;
#line 8 "../src/Plug.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SOUND_TYPE_PLUG, SoundPlug);
#line 9 "../src/Plug.vala"
	_g_object_unref0 (self->priv->box);
#line 10 "../src/Plug.vala"
	_g_object_unref0 (self->priv->stack);
#line 11 "../src/Plug.vala"
	_g_object_unref0 (self->priv->input_panel);
#line 8 "../src/Plug.vala"
	G_OBJECT_CLASS (sound_plug_parent_class)->finalize (obj);
#line 835 "Plug.c"
}

static GType
sound_plug_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SoundPlugClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sound_plug_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SoundPlug), 0, (GInstanceInitFunc) sound_plug_instance_init, NULL };
	GType sound_plug_type_id;
	sound_plug_type_id = g_type_register_static (SWITCHBOARD_TYPE_PLUG, "SoundPlug", &g_define_type_info, 0);
	SoundPlug_private_offset = g_type_add_instance_private (sound_plug_type_id, sizeof (SoundPlugPrivate));
	return sound_plug_type_id;
}

GType
sound_plug_get_type (void)
{
	static volatile gsize sound_plug_type_id__once = 0;
	if (g_once_init_enter (&sound_plug_type_id__once)) {
		GType sound_plug_type_id;
		sound_plug_type_id = sound_plug_get_type_once ();
		g_once_init_leave (&sound_plug_type_id__once, sound_plug_type_id);
	}
	return sound_plug_type_id__once;
}

SwitchboardPlug*
get_plug (GModule* module)
{
	SoundPlug* plug = NULL;
	SoundPlug* _tmp0_;
	SwitchboardPlug* result;
#line 113 "../src/Plug.vala"
	g_return_val_if_fail (module != NULL, NULL);
#line 114 "../src/Plug.vala"
	g_debug ("Plug.vala:114: Activating Sound plug");
#line 115 "../src/Plug.vala"
	_tmp0_ = sound_plug_new ();
#line 115 "../src/Plug.vala"
	plug = _tmp0_;
#line 116 "../src/Plug.vala"
	result = (SwitchboardPlug*) plug;
#line 116 "../src/Plug.vala"
	return result;
#line 878 "Plug.c"
}

static inline gpointer
_vala_memdup2 (gconstpointer mem,
               gsize byte_size)
{
	gpointer new_mem;
	if (mem && byte_size != 0) {
		new_mem = g_malloc (byte_size);
		memcpy (new_mem, mem, byte_size);
	} else {
		new_mem = NULL;
	}
	return new_mem;
}

