/* TestPopover.c generated by valac 0.56.17, the Vala compiler
 * generated from TestPopover.vala, do not modify */

/* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-*/
/*-
 * Copyright (c) 2016-2017 elementary LLC. (https://elementary.io)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 2 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
 * Boston, MA 02110-1301 USA.
 *
 * Authored by: Corentin Noël <corentin@elementary.io>
 */

#include "io.elementary.settings.sound.h"
#include <gtk/gtk.h>
#include <pulse/pulseaudio.h>
#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>
#include <canberra.h>
#include <granite-7.h>
#include <adwaita.h>
#include <gdk/gdk.h>

#if !defined(VALA_STRICT_C)
#if !defined(__clang__) && defined(__GNUC__) && (__GNUC__ >= 14)
#pragma GCC diagnostic warning "-Wincompatible-pointer-types"
#elif defined(__clang__) && (__clang_major__ >= 16)
#pragma clang diagnostic ignored "-Wincompatible-function-pointer-types"
#pragma clang diagnostic ignored "-Wincompatible-pointer-types"
#endif
#endif

enum  {
	SOUND_TEST_POPOVER_0_PROPERTY,
	SOUND_TEST_POPOVER_NUM_PROPERTIES
};
static GParamSpec* sound_test_popover_properties[SOUND_TEST_POPOVER_NUM_PROPERTIES];
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
enum  {
	SOUND_TEST_POPOVER_POSITION_BUTTON_0_PROPERTY,
	SOUND_TEST_POPOVER_POSITION_BUTTON_PA_POSITION_PROPERTY,
	SOUND_TEST_POPOVER_POSITION_BUTTON_NUM_PROPERTIES
};
static GParamSpec* sound_test_popover_position_button_properties[SOUND_TEST_POPOVER_POSITION_BUTTON_NUM_PROPERTIES];
#define _g_free0(var) (var = (g_free (var), NULL))
#define _ca_proplist_destroy0(var) ((var == NULL) ? NULL : (var = (ca_proplist_destroy (var), NULL)))

struct _SoundTestPopoverPrivate {
	GtkGrid* main_grid;
	SoundDevice* default_device;
};

struct _SoundTestPopoverPositionButtonPrivate {
	pa_channel_position_t _pa_position;
	gboolean playing;
	GtkImage* image;
};

static gint SoundTestPopover_private_offset;
static gpointer sound_test_popover_parent_class = NULL;
static gint SoundTestPopoverPositionButton_private_offset;
static gpointer sound_test_popover_position_button_parent_class = NULL;

static void sound_test_popover_create_position_button (SoundTestPopover* self,
                                                pa_channel_position_t pa_position);
static void sound_test_popover_default_changed (SoundTestPopover* self);
static void sound_test_popover_update_buttons (SoundTestPopover* self);
static void _sound_test_popover_update_buttons_g_object_notify (GObject* _sender,
                                                         GParamSpec* pspec,
                                                         gpointer self);
static void sound_test_popover_clear_buttons (SoundTestPopover* self);
static void sound_test_popover_add_buttons (SoundTestPopover* self);
static gchar* sound_test_popover_position_button_get_icon (SoundTestPopoverPositionButton* self);
static gchar* sound_test_popover_position_button_get_sound_name (SoundTestPopoverPositionButton* self);
static gchar* sound_test_popover_position_button_get_pretty_position (SoundTestPopoverPositionButton* self);
static void sound_test_popover_position_button_real_clicked (GtkButton* base);
static void sound_test_popover_position_button_play_full_callback (SoundTestPopoverPositionButton* self,
                                                            ca_context* c,
                                                            guint32 id,
                                                            gint code);
static void _sound_test_popover_position_button_play_full_callback_ca_finishcallback (ca_context* c,
                                                                               guint32 id,
                                                                               gint code,
                                                                               gpointer self);
static GObject * sound_test_popover_position_button_constructor (GType type,
                                                          guint n_construct_properties,
                                                          GObjectConstructParam * construct_properties);
static void sound_test_popover_position_button_finalize (GObject * obj);
static GType sound_test_popover_position_button_get_type_once (void);
static void _vala_sound_test_popover_position_button_get_property (GObject * object,
                                                            guint property_id,
                                                            GValue * value,
                                                            GParamSpec * pspec);
static void _vala_sound_test_popover_position_button_set_property (GObject * object,
                                                            guint property_id,
                                                            const GValue * value,
                                                            GParamSpec * pspec);
static GObject * sound_test_popover_constructor (GType type,
                                          guint n_construct_properties,
                                          GObjectConstructParam * construct_properties);
static void _sound_test_popover___lambda23_ (SoundTestPopover* self);
static void __sound_test_popover___lambda23__g_object_notify (GObject* _sender,
                                                       GParamSpec* pspec,
                                                       gpointer self);
static void sound_test_popover_finalize (GObject * obj);
static GType sound_test_popover_get_type_once (void);

static inline gpointer
sound_test_popover_get_instance_private (SoundTestPopover* self)
{
	return G_STRUCT_MEMBER_P (self, SoundTestPopover_private_offset);
}

static void
sound_test_popover_create_position_button (SoundTestPopover* self,
                                           pa_channel_position_t pa_position)
{
	SoundTestPopoverPositionButton* button = NULL;
	SoundTestPopoverPositionButton* _tmp0_;
#line 53 "../src/TestPopover.vala"
	g_return_if_fail (self != NULL);
#line 54 "../src/TestPopover.vala"
	_tmp0_ = sound_test_popover_position_button_new (pa_position);
#line 54 "../src/TestPopover.vala"
	g_object_ref_sink (_tmp0_);
#line 54 "../src/TestPopover.vala"
	button = _tmp0_;
#line 55 "../src/TestPopover.vala"
	switch (pa_position) {
#line 55 "../src/TestPopover.vala"
		case PA_CHANNEL_POSITION_FRONT_LEFT:
#line 147 "TestPopover.c"
		{
			GtkGrid* _tmp1_;
			SoundTestPopoverPositionButton* _tmp2_;
#line 57 "../src/TestPopover.vala"
			_tmp1_ = self->priv->main_grid;
#line 57 "../src/TestPopover.vala"
			_tmp2_ = button;
#line 57 "../src/TestPopover.vala"
			gtk_grid_attach (_tmp1_, (GtkWidget*) _tmp2_, 0, 0, 1, 1);
#line 58 "../src/TestPopover.vala"
			break;
#line 159 "TestPopover.c"
		}
#line 55 "../src/TestPopover.vala"
		case PA_CHANNEL_POSITION_FRONT_RIGHT:
#line 163 "TestPopover.c"
		{
			GtkGrid* _tmp3_;
			SoundTestPopoverPositionButton* _tmp4_;
#line 60 "../src/TestPopover.vala"
			_tmp3_ = self->priv->main_grid;
#line 60 "../src/TestPopover.vala"
			_tmp4_ = button;
#line 60 "../src/TestPopover.vala"
			gtk_grid_attach (_tmp3_, (GtkWidget*) _tmp4_, 4, 0, 1, 1);
#line 61 "../src/TestPopover.vala"
			break;
#line 175 "TestPopover.c"
		}
#line 55 "../src/TestPopover.vala"
		case PA_CHANNEL_POSITION_FRONT_CENTER:
#line 179 "TestPopover.c"
		{
			GtkGrid* _tmp5_;
			SoundTestPopoverPositionButton* _tmp6_;
#line 63 "../src/TestPopover.vala"
			_tmp5_ = self->priv->main_grid;
#line 63 "../src/TestPopover.vala"
			_tmp6_ = button;
#line 63 "../src/TestPopover.vala"
			gtk_grid_attach (_tmp5_, (GtkWidget*) _tmp6_, 2, 0, 1, 1);
#line 64 "../src/TestPopover.vala"
			break;
#line 191 "TestPopover.c"
		}
#line 55 "../src/TestPopover.vala"
		case PA_CHANNEL_POSITION_REAR_LEFT:
#line 195 "TestPopover.c"
		{
			GtkGrid* _tmp7_;
			SoundTestPopoverPositionButton* _tmp8_;
#line 66 "../src/TestPopover.vala"
			_tmp7_ = self->priv->main_grid;
#line 66 "../src/TestPopover.vala"
			_tmp8_ = button;
#line 66 "../src/TestPopover.vala"
			gtk_grid_attach (_tmp7_, (GtkWidget*) _tmp8_, 0, 2, 1, 1);
#line 67 "../src/TestPopover.vala"
			break;
#line 207 "TestPopover.c"
		}
#line 55 "../src/TestPopover.vala"
		case PA_CHANNEL_POSITION_REAR_RIGHT:
#line 211 "TestPopover.c"
		{
			GtkGrid* _tmp9_;
			SoundTestPopoverPositionButton* _tmp10_;
#line 69 "../src/TestPopover.vala"
			_tmp9_ = self->priv->main_grid;
#line 69 "../src/TestPopover.vala"
			_tmp10_ = button;
#line 69 "../src/TestPopover.vala"
			gtk_grid_attach (_tmp9_, (GtkWidget*) _tmp10_, 4, 2, 1, 1);
#line 70 "../src/TestPopover.vala"
			break;
#line 223 "TestPopover.c"
		}
#line 55 "../src/TestPopover.vala"
		case PA_CHANNEL_POSITION_REAR_CENTER:
#line 227 "TestPopover.c"
		{
			GtkGrid* _tmp11_;
			SoundTestPopoverPositionButton* _tmp12_;
#line 72 "../src/TestPopover.vala"
			_tmp11_ = self->priv->main_grid;
#line 72 "../src/TestPopover.vala"
			_tmp12_ = button;
#line 72 "../src/TestPopover.vala"
			gtk_grid_attach (_tmp11_, (GtkWidget*) _tmp12_, 2, 2, 1, 1);
#line 73 "../src/TestPopover.vala"
			break;
#line 239 "TestPopover.c"
		}
#line 55 "../src/TestPopover.vala"
		case PA_CHANNEL_POSITION_LFE:
#line 243 "TestPopover.c"
		{
			GtkGrid* _tmp13_;
			SoundTestPopoverPositionButton* _tmp14_;
#line 75 "../src/TestPopover.vala"
			_tmp13_ = self->priv->main_grid;
#line 75 "../src/TestPopover.vala"
			_tmp14_ = button;
#line 75 "../src/TestPopover.vala"
			gtk_grid_attach (_tmp13_, (GtkWidget*) _tmp14_, 3, 2, 1, 1);
#line 76 "../src/TestPopover.vala"
			break;
#line 255 "TestPopover.c"
		}
#line 55 "../src/TestPopover.vala"
		case PA_CHANNEL_POSITION_SIDE_LEFT:
#line 259 "TestPopover.c"
		{
			GtkGrid* _tmp15_;
			SoundTestPopoverPositionButton* _tmp16_;
#line 78 "../src/TestPopover.vala"
			_tmp15_ = self->priv->main_grid;
#line 78 "../src/TestPopover.vala"
			_tmp16_ = button;
#line 78 "../src/TestPopover.vala"
			gtk_grid_attach (_tmp15_, (GtkWidget*) _tmp16_, 0, 1, 1, 1);
#line 79 "../src/TestPopover.vala"
			break;
#line 271 "TestPopover.c"
		}
#line 55 "../src/TestPopover.vala"
		case PA_CHANNEL_POSITION_SIDE_RIGHT:
#line 275 "TestPopover.c"
		{
			GtkGrid* _tmp17_;
			SoundTestPopoverPositionButton* _tmp18_;
#line 81 "../src/TestPopover.vala"
			_tmp17_ = self->priv->main_grid;
#line 81 "../src/TestPopover.vala"
			_tmp18_ = button;
#line 81 "../src/TestPopover.vala"
			gtk_grid_attach (_tmp17_, (GtkWidget*) _tmp18_, 4, 1, 1, 1);
#line 82 "../src/TestPopover.vala"
			break;
#line 287 "TestPopover.c"
		}
#line 55 "../src/TestPopover.vala"
		case PA_CHANNEL_POSITION_FRONT_LEFT_OF_CENTER:
#line 291 "TestPopover.c"
		{
			GtkGrid* _tmp19_;
			SoundTestPopoverPositionButton* _tmp20_;
#line 84 "../src/TestPopover.vala"
			_tmp19_ = self->priv->main_grid;
#line 84 "../src/TestPopover.vala"
			_tmp20_ = button;
#line 84 "../src/TestPopover.vala"
			gtk_grid_attach (_tmp19_, (GtkWidget*) _tmp20_, 1, 0, 1, 1);
#line 85 "../src/TestPopover.vala"
			break;
#line 303 "TestPopover.c"
		}
#line 55 "../src/TestPopover.vala"
		case PA_CHANNEL_POSITION_FRONT_RIGHT_OF_CENTER:
#line 307 "TestPopover.c"
		{
			GtkGrid* _tmp21_;
			SoundTestPopoverPositionButton* _tmp22_;
#line 87 "../src/TestPopover.vala"
			_tmp21_ = self->priv->main_grid;
#line 87 "../src/TestPopover.vala"
			_tmp22_ = button;
#line 87 "../src/TestPopover.vala"
			gtk_grid_attach (_tmp21_, (GtkWidget*) _tmp22_, 3, 0, 1, 1);
#line 88 "../src/TestPopover.vala"
			break;
#line 319 "TestPopover.c"
		}
#line 55 "../src/TestPopover.vala"
		case PA_CHANNEL_POSITION_MONO:
#line 323 "TestPopover.c"
		{
			GtkGrid* _tmp23_;
			SoundTestPopoverPositionButton* _tmp24_;
#line 90 "../src/TestPopover.vala"
			_tmp23_ = self->priv->main_grid;
#line 90 "../src/TestPopover.vala"
			_tmp24_ = button;
#line 90 "../src/TestPopover.vala"
			gtk_grid_attach (_tmp23_, (GtkWidget*) _tmp24_, 2, 0, 1, 1);
#line 91 "../src/TestPopover.vala"
			break;
#line 335 "TestPopover.c"
		}
		default:
#line 55 "../src/TestPopover.vala"
		break;
#line 340 "TestPopover.c"
	}
#line 53 "../src/TestPopover.vala"
	_g_object_unref0 (button);
#line 344 "TestPopover.c"
}

static void
_sound_test_popover_update_buttons_g_object_notify (GObject* _sender,
                                                    GParamSpec* pspec,
                                                    gpointer self)
{
#line 97 "../src/TestPopover.vala"
	sound_test_popover_update_buttons ((SoundTestPopover*) self);
#line 354 "TestPopover.c"
}

static gpointer
_g_object_ref0 (gpointer self)
{
#line 102 "../src/TestPopover.vala"
	return self ? g_object_ref (self) : NULL;
#line 362 "TestPopover.c"
}

static void
sound_test_popover_default_changed (SoundTestPopover* self)
{
	SoundDevice* _tmp0_;
	SoundPulseAudioManager* pam = NULL;
	SoundPulseAudioManager* _tmp3_;
	SoundDevice* _tmp4_;
	SoundDevice* _tmp5_;
	SoundDevice* _tmp6_;
	SoundDevice* _tmp7_;
#line 95 "../src/TestPopover.vala"
	g_return_if_fail (self != NULL);
#line 96 "../src/TestPopover.vala"
	_tmp0_ = self->priv->default_device;
#line 96 "../src/TestPopover.vala"
	if (_tmp0_ != NULL) {
#line 381 "TestPopover.c"
		SoundDevice* _tmp1_;
		guint _tmp2_;
#line 97 "../src/TestPopover.vala"
		_tmp1_ = self->priv->default_device;
#line 97 "../src/TestPopover.vala"
		g_signal_parse_name ("notify", G_TYPE_OBJECT, &_tmp2_, NULL, FALSE);
#line 97 "../src/TestPopover.vala"
		g_signal_handlers_disconnect_matched ((GObject*) _tmp1_, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _tmp2_, 0, NULL, (GCallback) _sound_test_popover_update_buttons_g_object_notify, self);
#line 98 "../src/TestPopover.vala"
		sound_test_popover_clear_buttons (self);
#line 392 "TestPopover.c"
	}
#line 101 "../src/TestPopover.vala"
	_tmp3_ = sound_pulse_audio_manager_get_default ();
#line 101 "../src/TestPopover.vala"
	pam = _tmp3_;
#line 102 "../src/TestPopover.vala"
	_tmp4_ = sound_pulse_audio_manager_get_default_output (pam);
#line 102 "../src/TestPopover.vala"
	_tmp5_ = _tmp4_;
#line 102 "../src/TestPopover.vala"
	_tmp6_ = _g_object_ref0 (_tmp5_);
#line 102 "../src/TestPopover.vala"
	_g_object_unref0 (self->priv->default_device);
#line 102 "../src/TestPopover.vala"
	self->priv->default_device = _tmp6_;
#line 103 "../src/TestPopover.vala"
	_tmp7_ = self->priv->default_device;
#line 103 "../src/TestPopover.vala"
	g_signal_connect_object ((GObject*) _tmp7_, "notify::channel-map", (GCallback) _sound_test_popover_update_buttons_g_object_notify, self, 0);
#line 104 "../src/TestPopover.vala"
	sound_test_popover_add_buttons (self);
#line 414 "TestPopover.c"
}

static void
sound_test_popover_update_buttons (SoundTestPopover* self)
{
#line 107 "../src/TestPopover.vala"
	g_return_if_fail (self != NULL);
#line 108 "../src/TestPopover.vala"
	sound_test_popover_clear_buttons (self);
#line 109 "../src/TestPopover.vala"
	sound_test_popover_add_buttons (self);
#line 426 "TestPopover.c"
}

static void
sound_test_popover_clear_buttons (SoundTestPopover* self)
{
	GtkWidget* child = NULL;
	GtkGrid* _tmp0_;
	GtkWidget* _tmp1_;
#line 112 "../src/TestPopover.vala"
	g_return_if_fail (self != NULL);
#line 113 "../src/TestPopover.vala"
	_tmp0_ = self->priv->main_grid;
#line 113 "../src/TestPopover.vala"
	_tmp1_ = gtk_widget_get_first_child ((GtkWidget*) _tmp0_);
#line 113 "../src/TestPopover.vala"
	child = _tmp1_;
#line 114 "../src/TestPopover.vala"
	while (TRUE) {
#line 445 "TestPopover.c"
		GtkWidget* _tmp2_;
		GtkWidget* _tmp3_;
		GtkWidget* _tmp6_;
		GtkWidget* _tmp7_;
#line 114 "../src/TestPopover.vala"
		_tmp2_ = child;
#line 114 "../src/TestPopover.vala"
		if (!(_tmp2_ != NULL)) {
#line 114 "../src/TestPopover.vala"
			break;
#line 456 "TestPopover.c"
		}
#line 115 "../src/TestPopover.vala"
		_tmp3_ = child;
#line 115 "../src/TestPopover.vala"
		if (SOUND_TEST_POPOVER_IS_POSITION_BUTTON (_tmp3_)) {
#line 462 "TestPopover.c"
			GtkGrid* _tmp4_;
			GtkWidget* _tmp5_;
#line 116 "../src/TestPopover.vala"
			_tmp4_ = self->priv->main_grid;
#line 116 "../src/TestPopover.vala"
			_tmp5_ = child;
#line 116 "../src/TestPopover.vala"
			gtk_grid_remove (_tmp4_, _tmp5_);
#line 471 "TestPopover.c"
		}
#line 119 "../src/TestPopover.vala"
		_tmp6_ = child;
#line 119 "../src/TestPopover.vala"
		_tmp7_ = gtk_widget_get_next_sibling (_tmp6_);
#line 119 "../src/TestPopover.vala"
		child = _tmp7_;
#line 479 "TestPopover.c"
	}
}

static void
sound_test_popover_add_buttons (SoundTestPopover* self)
{
	SoundDevice* _tmp0_;
	pa_channel_map _tmp1_;
#line 123 "../src/TestPopover.vala"
	g_return_if_fail (self != NULL);
#line 124 "../src/TestPopover.vala"
	_tmp0_ = self->priv->default_device;
#line 124 "../src/TestPopover.vala"
	_tmp1_ = _tmp0_->channel_map;
#line 494 "TestPopover.c"
	{
		pa_channel_position_t* position_collection = NULL;
		gint position_collection_length1 = 0;
		gint _position_collection_size_ = 0;
		gint position_it = 0;
#line 124 "../src/TestPopover.vala"
		position_collection = _tmp1_.map;
#line 124 "../src/TestPopover.vala"
		position_collection_length1 = 32;
#line 124 "../src/TestPopover.vala"
		for (position_it = 0; position_it < position_collection_length1; position_it = position_it + 1) {
#line 506 "TestPopover.c"
			pa_channel_position_t position = 0;
#line 124 "../src/TestPopover.vala"
			position = position_collection[position_it];
#line 510 "TestPopover.c"
			{
				gboolean _tmp2_ = FALSE;
#line 125 "../src/TestPopover.vala"
				if (position > 0) {
#line 125 "../src/TestPopover.vala"
					_tmp2_ = position < PA_CHANNEL_POSITION_MAX;
#line 517 "TestPopover.c"
				} else {
#line 125 "../src/TestPopover.vala"
					_tmp2_ = FALSE;
#line 521 "TestPopover.c"
				}
#line 125 "../src/TestPopover.vala"
				if (_tmp2_) {
#line 126 "../src/TestPopover.vala"
					sound_test_popover_create_position_button (self, position);
#line 527 "TestPopover.c"
				}
			}
		}
	}
}

SoundTestPopover*
sound_test_popover_construct (GType object_type)
{
	SoundTestPopover * self = NULL;
#line 23 "../src/TestPopover.vala"
	self = (SoundTestPopover*) g_object_new (object_type, NULL);
#line 23 "../src/TestPopover.vala"
	return self;
#line 542 "TestPopover.c"
}

SoundTestPopover*
sound_test_popover_new (void)
{
#line 23 "../src/TestPopover.vala"
	return sound_test_popover_construct (SOUND_TYPE_TEST_POPOVER);
#line 550 "TestPopover.c"
}

static inline gpointer
sound_test_popover_position_button_get_instance_private (SoundTestPopoverPositionButton* self)
{
	return G_STRUCT_MEMBER_P (self, SoundTestPopoverPositionButton_private_offset);
}

SoundTestPopoverPositionButton*
sound_test_popover_position_button_construct (GType object_type,
                                              pa_channel_position_t pa_position)
{
	SoundTestPopoverPositionButton * self = NULL;
#line 137 "../src/TestPopover.vala"
	self = (SoundTestPopoverPositionButton*) g_object_new (object_type, "pa-position", pa_position, NULL);
#line 136 "../src/TestPopover.vala"
	return self;
#line 568 "TestPopover.c"
}

SoundTestPopoverPositionButton*
sound_test_popover_position_button_new (pa_channel_position_t pa_position)
{
#line 136 "../src/TestPopover.vala"
	return sound_test_popover_position_button_construct (SOUND_TEST_POPOVER_TYPE_POSITION_BUTTON, pa_position);
#line 576 "TestPopover.c"
}

static gchar*
sound_test_popover_position_button_get_icon (SoundTestPopoverPositionButton* self)
{
	pa_channel_position_t _tmp0_;
	gchar* result;
#line 150 "../src/TestPopover.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 151 "../src/TestPopover.vala"
	_tmp0_ = self->priv->_pa_position;
#line 151 "../src/TestPopover.vala"
	switch (_tmp0_) {
#line 151 "../src/TestPopover.vala"
		case PA_CHANNEL_POSITION_FRONT_LEFT:
#line 592 "TestPopover.c"
		{
			const gchar* _tmp1_ = NULL;
			gchar* _tmp2_;
#line 153 "../src/TestPopover.vala"
			if (self->priv->playing) {
#line 153 "../src/TestPopover.vala"
				_tmp1_ = "audio-speaker-left-testing";
#line 600 "TestPopover.c"
			} else {
#line 153 "../src/TestPopover.vala"
				_tmp1_ = "audio-speaker-left";
#line 604 "TestPopover.c"
			}
#line 153 "../src/TestPopover.vala"
			_tmp2_ = g_strdup (_tmp1_);
#line 153 "../src/TestPopover.vala"
			result = _tmp2_;
#line 153 "../src/TestPopover.vala"
			return result;
#line 612 "TestPopover.c"
		}
#line 151 "../src/TestPopover.vala"
		case PA_CHANNEL_POSITION_FRONT_RIGHT:
#line 616 "TestPopover.c"
		{
			const gchar* _tmp3_ = NULL;
			gchar* _tmp4_;
#line 155 "../src/TestPopover.vala"
			if (self->priv->playing) {
#line 155 "../src/TestPopover.vala"
				_tmp3_ = "audio-speaker-right-testing";
#line 624 "TestPopover.c"
			} else {
#line 155 "../src/TestPopover.vala"
				_tmp3_ = "audio-speaker-right";
#line 628 "TestPopover.c"
			}
#line 155 "../src/TestPopover.vala"
			_tmp4_ = g_strdup (_tmp3_);
#line 155 "../src/TestPopover.vala"
			result = _tmp4_;
#line 155 "../src/TestPopover.vala"
			return result;
#line 636 "TestPopover.c"
		}
#line 151 "../src/TestPopover.vala"
		case PA_CHANNEL_POSITION_FRONT_CENTER:
#line 640 "TestPopover.c"
		{
			const gchar* _tmp5_ = NULL;
			gchar* _tmp6_;
#line 157 "../src/TestPopover.vala"
			if (self->priv->playing) {
#line 157 "../src/TestPopover.vala"
				_tmp5_ = "audio-speaker-center-testing";
#line 648 "TestPopover.c"
			} else {
#line 157 "../src/TestPopover.vala"
				_tmp5_ = "audio-speaker-center";
#line 652 "TestPopover.c"
			}
#line 157 "../src/TestPopover.vala"
			_tmp6_ = g_strdup (_tmp5_);
#line 157 "../src/TestPopover.vala"
			result = _tmp6_;
#line 157 "../src/TestPopover.vala"
			return result;
#line 660 "TestPopover.c"
		}
#line 151 "../src/TestPopover.vala"
		case PA_CHANNEL_POSITION_REAR_LEFT:
#line 664 "TestPopover.c"
		{
			const gchar* _tmp7_ = NULL;
			gchar* _tmp8_;
#line 159 "../src/TestPopover.vala"
			if (self->priv->playing) {
#line 159 "../src/TestPopover.vala"
				_tmp7_ = "audio-speaker-left-back-testing";
#line 672 "TestPopover.c"
			} else {
#line 159 "../src/TestPopover.vala"
				_tmp7_ = "audio-speaker-left-back";
#line 676 "TestPopover.c"
			}
#line 159 "../src/TestPopover.vala"
			_tmp8_ = g_strdup (_tmp7_);
#line 159 "../src/TestPopover.vala"
			result = _tmp8_;
#line 159 "../src/TestPopover.vala"
			return result;
#line 684 "TestPopover.c"
		}
#line 151 "../src/TestPopover.vala"
		case PA_CHANNEL_POSITION_REAR_RIGHT:
#line 688 "TestPopover.c"
		{
			const gchar* _tmp9_ = NULL;
			gchar* _tmp10_;
#line 161 "../src/TestPopover.vala"
			if (self->priv->playing) {
#line 161 "../src/TestPopover.vala"
				_tmp9_ = "audio-speaker-right-back-testing";
#line 696 "TestPopover.c"
			} else {
#line 161 "../src/TestPopover.vala"
				_tmp9_ = "audio-speaker-right-back";
#line 700 "TestPopover.c"
			}
#line 161 "../src/TestPopover.vala"
			_tmp10_ = g_strdup (_tmp9_);
#line 161 "../src/TestPopover.vala"
			result = _tmp10_;
#line 161 "../src/TestPopover.vala"
			return result;
#line 708 "TestPopover.c"
		}
#line 151 "../src/TestPopover.vala"
		case PA_CHANNEL_POSITION_REAR_CENTER:
#line 712 "TestPopover.c"
		{
			const gchar* _tmp11_ = NULL;
			gchar* _tmp12_;
#line 163 "../src/TestPopover.vala"
			if (self->priv->playing) {
#line 163 "../src/TestPopover.vala"
				_tmp11_ = "audio-speaker-center-back-testing";
#line 720 "TestPopover.c"
			} else {
#line 163 "../src/TestPopover.vala"
				_tmp11_ = "audio-speaker-center-back";
#line 724 "TestPopover.c"
			}
#line 163 "../src/TestPopover.vala"
			_tmp12_ = g_strdup (_tmp11_);
#line 163 "../src/TestPopover.vala"
			result = _tmp12_;
#line 163 "../src/TestPopover.vala"
			return result;
#line 732 "TestPopover.c"
		}
#line 151 "../src/TestPopover.vala"
		case PA_CHANNEL_POSITION_LFE:
#line 736 "TestPopover.c"
		{
			const gchar* _tmp13_ = NULL;
			gchar* _tmp14_;
#line 165 "../src/TestPopover.vala"
			if (self->priv->playing) {
#line 165 "../src/TestPopover.vala"
				_tmp13_ = "audio-subwoofer-testing";
#line 744 "TestPopover.c"
			} else {
#line 165 "../src/TestPopover.vala"
				_tmp13_ = "audio-subwoofer";
#line 748 "TestPopover.c"
			}
#line 165 "../src/TestPopover.vala"
			_tmp14_ = g_strdup (_tmp13_);
#line 165 "../src/TestPopover.vala"
			result = _tmp14_;
#line 165 "../src/TestPopover.vala"
			return result;
#line 756 "TestPopover.c"
		}
#line 151 "../src/TestPopover.vala"
		case PA_CHANNEL_POSITION_SIDE_LEFT:
#line 760 "TestPopover.c"
		{
			const gchar* _tmp15_ = NULL;
			gchar* _tmp16_;
#line 167 "../src/TestPopover.vala"
			if (self->priv->playing) {
#line 167 "../src/TestPopover.vala"
				_tmp15_ = "audio-speaker-left-side-testing";
#line 768 "TestPopover.c"
			} else {
#line 167 "../src/TestPopover.vala"
				_tmp15_ = "audio-speaker-left-side";
#line 772 "TestPopover.c"
			}
#line 167 "../src/TestPopover.vala"
			_tmp16_ = g_strdup (_tmp15_);
#line 167 "../src/TestPopover.vala"
			result = _tmp16_;
#line 167 "../src/TestPopover.vala"
			return result;
#line 780 "TestPopover.c"
		}
#line 151 "../src/TestPopover.vala"
		case PA_CHANNEL_POSITION_SIDE_RIGHT:
#line 784 "TestPopover.c"
		{
			const gchar* _tmp17_ = NULL;
			gchar* _tmp18_;
#line 169 "../src/TestPopover.vala"
			if (self->priv->playing) {
#line 169 "../src/TestPopover.vala"
				_tmp17_ = "audio-speaker-right-side-testing";
#line 792 "TestPopover.c"
			} else {
#line 169 "../src/TestPopover.vala"
				_tmp17_ = "audio-speaker-right-side";
#line 796 "TestPopover.c"
			}
#line 169 "../src/TestPopover.vala"
			_tmp18_ = g_strdup (_tmp17_);
#line 169 "../src/TestPopover.vala"
			result = _tmp18_;
#line 169 "../src/TestPopover.vala"
			return result;
#line 804 "TestPopover.c"
		}
#line 151 "../src/TestPopover.vala"
		case PA_CHANNEL_POSITION_FRONT_LEFT_OF_CENTER:
#line 808 "TestPopover.c"
		{
			const gchar* _tmp19_ = NULL;
			gchar* _tmp20_;
#line 171 "../src/TestPopover.vala"
			if (self->priv->playing) {
#line 171 "../src/TestPopover.vala"
				_tmp19_ = "audio-speaker-front-left-of-center-testing";
#line 816 "TestPopover.c"
			} else {
#line 171 "../src/TestPopover.vala"
				_tmp19_ = "audio-speaker-front-left-of-center";
#line 820 "TestPopover.c"
			}
#line 171 "../src/TestPopover.vala"
			_tmp20_ = g_strdup (_tmp19_);
#line 171 "../src/TestPopover.vala"
			result = _tmp20_;
#line 171 "../src/TestPopover.vala"
			return result;
#line 828 "TestPopover.c"
		}
#line 151 "../src/TestPopover.vala"
		case PA_CHANNEL_POSITION_FRONT_RIGHT_OF_CENTER:
#line 832 "TestPopover.c"
		{
			const gchar* _tmp21_ = NULL;
			gchar* _tmp22_;
#line 173 "../src/TestPopover.vala"
			if (self->priv->playing) {
#line 173 "../src/TestPopover.vala"
				_tmp21_ = "audio-speaker-front-right-of-center-testing";
#line 840 "TestPopover.c"
			} else {
#line 173 "../src/TestPopover.vala"
				_tmp21_ = "audio-speaker-front-right-of-center";
#line 844 "TestPopover.c"
			}
#line 173 "../src/TestPopover.vala"
			_tmp22_ = g_strdup (_tmp21_);
#line 173 "../src/TestPopover.vala"
			result = _tmp22_;
#line 173 "../src/TestPopover.vala"
			return result;
#line 852 "TestPopover.c"
		}
#line 151 "../src/TestPopover.vala"
		case PA_CHANNEL_POSITION_MONO:
#line 856 "TestPopover.c"
		{
			const gchar* _tmp23_ = NULL;
			gchar* _tmp24_;
#line 175 "../src/TestPopover.vala"
			if (self->priv->playing) {
#line 175 "../src/TestPopover.vala"
				_tmp23_ = "audio-speaker-mono-testing";
#line 864 "TestPopover.c"
			} else {
#line 175 "../src/TestPopover.vala"
				_tmp23_ = "audio-speaker-mono";
#line 868 "TestPopover.c"
			}
#line 175 "../src/TestPopover.vala"
			_tmp24_ = g_strdup (_tmp23_);
#line 175 "../src/TestPopover.vala"
			result = _tmp24_;
#line 175 "../src/TestPopover.vala"
			return result;
#line 876 "TestPopover.c"
		}
		default:
		{
			gchar* _tmp25_;
#line 177 "../src/TestPopover.vala"
			_tmp25_ = g_strdup ("audio-speaker-mono");
#line 177 "../src/TestPopover.vala"
			result = _tmp25_;
#line 177 "../src/TestPopover.vala"
			return result;
#line 887 "TestPopover.c"
		}
	}
}

static gchar*
sound_test_popover_position_button_get_sound_name (SoundTestPopoverPositionButton* self)
{
	pa_channel_position_t _tmp0_;
	gchar* result;
#line 181 "../src/TestPopover.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 182 "../src/TestPopover.vala"
	_tmp0_ = self->priv->_pa_position;
#line 182 "../src/TestPopover.vala"
	switch (_tmp0_) {
#line 182 "../src/TestPopover.vala"
		case PA_CHANNEL_POSITION_FRONT_LEFT:
#line 905 "TestPopover.c"
		{
			gchar* _tmp1_;
#line 184 "../src/TestPopover.vala"
			_tmp1_ = g_strdup ("audio-channel-front-left");
#line 184 "../src/TestPopover.vala"
			result = _tmp1_;
#line 184 "../src/TestPopover.vala"
			return result;
#line 914 "TestPopover.c"
		}
#line 182 "../src/TestPopover.vala"
		case PA_CHANNEL_POSITION_FRONT_RIGHT:
#line 918 "TestPopover.c"
		{
			gchar* _tmp2_;
#line 186 "../src/TestPopover.vala"
			_tmp2_ = g_strdup ("audio-channel-front-right");
#line 186 "../src/TestPopover.vala"
			result = _tmp2_;
#line 186 "../src/TestPopover.vala"
			return result;
#line 927 "TestPopover.c"
		}
#line 182 "../src/TestPopover.vala"
		case PA_CHANNEL_POSITION_FRONT_CENTER:
#line 931 "TestPopover.c"
		{
			gchar* _tmp3_;
#line 188 "../src/TestPopover.vala"
			_tmp3_ = g_strdup ("audio-channel-front-center");
#line 188 "../src/TestPopover.vala"
			result = _tmp3_;
#line 188 "../src/TestPopover.vala"
			return result;
#line 940 "TestPopover.c"
		}
#line 182 "../src/TestPopover.vala"
		case PA_CHANNEL_POSITION_REAR_LEFT:
#line 944 "TestPopover.c"
		{
			gchar* _tmp4_;
#line 190 "../src/TestPopover.vala"
			_tmp4_ = g_strdup ("audio-channel-rear-left");
#line 190 "../src/TestPopover.vala"
			result = _tmp4_;
#line 190 "../src/TestPopover.vala"
			return result;
#line 953 "TestPopover.c"
		}
#line 182 "../src/TestPopover.vala"
		case PA_CHANNEL_POSITION_REAR_RIGHT:
#line 957 "TestPopover.c"
		{
			gchar* _tmp5_;
#line 192 "../src/TestPopover.vala"
			_tmp5_ = g_strdup ("audio-channel-rear-right");
#line 192 "../src/TestPopover.vala"
			result = _tmp5_;
#line 192 "../src/TestPopover.vala"
			return result;
#line 966 "TestPopover.c"
		}
#line 182 "../src/TestPopover.vala"
		case PA_CHANNEL_POSITION_REAR_CENTER:
#line 970 "TestPopover.c"
		{
			gchar* _tmp6_;
#line 194 "../src/TestPopover.vala"
			_tmp6_ = g_strdup ("audio-channel-rear-center");
#line 194 "../src/TestPopover.vala"
			result = _tmp6_;
#line 194 "../src/TestPopover.vala"
			return result;
#line 979 "TestPopover.c"
		}
#line 182 "../src/TestPopover.vala"
		case PA_CHANNEL_POSITION_LFE:
#line 983 "TestPopover.c"
		{
			gchar* _tmp7_;
#line 196 "../src/TestPopover.vala"
			_tmp7_ = g_strdup ("audio-channel-lfe");
#line 196 "../src/TestPopover.vala"
			result = _tmp7_;
#line 196 "../src/TestPopover.vala"
			return result;
#line 992 "TestPopover.c"
		}
#line 182 "../src/TestPopover.vala"
		case PA_CHANNEL_POSITION_SIDE_LEFT:
#line 996 "TestPopover.c"
		{
			gchar* _tmp8_;
#line 198 "../src/TestPopover.vala"
			_tmp8_ = g_strdup ("audio-channel-side-left");
#line 198 "../src/TestPopover.vala"
			result = _tmp8_;
#line 198 "../src/TestPopover.vala"
			return result;
#line 1005 "TestPopover.c"
		}
#line 182 "../src/TestPopover.vala"
		case PA_CHANNEL_POSITION_SIDE_RIGHT:
#line 1009 "TestPopover.c"
		{
			gchar* _tmp9_;
#line 200 "../src/TestPopover.vala"
			_tmp9_ = g_strdup ("audio-channel-side-right");
#line 200 "../src/TestPopover.vala"
			result = _tmp9_;
#line 200 "../src/TestPopover.vala"
			return result;
#line 1018 "TestPopover.c"
		}
#line 182 "../src/TestPopover.vala"
		case PA_CHANNEL_POSITION_FRONT_LEFT_OF_CENTER:
#line 1022 "TestPopover.c"
		{
			gchar* _tmp10_;
#line 202 "../src/TestPopover.vala"
			_tmp10_ = g_strdup ("audio-channel-front-left-of-center");
#line 202 "../src/TestPopover.vala"
			result = _tmp10_;
#line 202 "../src/TestPopover.vala"
			return result;
#line 1031 "TestPopover.c"
		}
#line 182 "../src/TestPopover.vala"
		case PA_CHANNEL_POSITION_FRONT_RIGHT_OF_CENTER:
#line 1035 "TestPopover.c"
		{
			gchar* _tmp11_;
#line 204 "../src/TestPopover.vala"
			_tmp11_ = g_strdup ("audio-channel-front-right-of-center");
#line 204 "../src/TestPopover.vala"
			result = _tmp11_;
#line 204 "../src/TestPopover.vala"
			return result;
#line 1044 "TestPopover.c"
		}
#line 182 "../src/TestPopover.vala"
		case PA_CHANNEL_POSITION_MONO:
#line 1048 "TestPopover.c"
		{
			gchar* _tmp12_;
#line 206 "../src/TestPopover.vala"
			_tmp12_ = g_strdup ("audio-channel-mono");
#line 206 "../src/TestPopover.vala"
			result = _tmp12_;
#line 206 "../src/TestPopover.vala"
			return result;
#line 1057 "TestPopover.c"
		}
		default:
		{
			gchar* _tmp13_;
#line 208 "../src/TestPopover.vala"
			_tmp13_ = g_strdup ("audio-test-signal");
#line 208 "../src/TestPopover.vala"
			result = _tmp13_;
#line 208 "../src/TestPopover.vala"
			return result;
#line 1068 "TestPopover.c"
		}
	}
}

static gchar*
sound_test_popover_position_button_get_pretty_position (SoundTestPopoverPositionButton* self)
{
	pa_channel_position_t _tmp0_;
	pa_channel_position_t _tmp2_;
	const gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* result;
#line 212 "../src/TestPopover.vala"
	g_return_val_if_fail (self != NULL, NULL);
#line 213 "../src/TestPopover.vala"
	_tmp0_ = self->priv->_pa_position;
#line 213 "../src/TestPopover.vala"
	if (_tmp0_ == PA_CHANNEL_POSITION_LFE) {
#line 1087 "TestPopover.c"
		gchar* _tmp1_;
#line 214 "../src/TestPopover.vala"
		_tmp1_ = g_strdup ("Subwoofer");
#line 214 "../src/TestPopover.vala"
		result = _tmp1_;
#line 214 "../src/TestPopover.vala"
		return result;
#line 1095 "TestPopover.c"
	}
#line 217 "../src/TestPopover.vala"
	_tmp2_ = self->priv->_pa_position;
#line 217 "../src/TestPopover.vala"
	_tmp3_ = pa_channel_position_to_pretty_string (_tmp2_);
#line 217 "../src/TestPopover.vala"
	_tmp4_ = g_strdup (_tmp3_);
#line 217 "../src/TestPopover.vala"
	result = _tmp4_;
#line 217 "../src/TestPopover.vala"
	return result;
#line 1107 "TestPopover.c"
}

static void
_sound_test_popover_position_button_play_full_callback_ca_finishcallback (ca_context* c,
                                                                          guint32 id,
                                                                          gint code,
                                                                          gpointer self)
{
#line 231 "../src/TestPopover.vala"
	sound_test_popover_position_button_play_full_callback ((SoundTestPopoverPositionButton*) self, c, id, code);
#line 1118 "TestPopover.c"
}

static void
sound_test_popover_position_button_real_clicked (GtkButton* base)
{
	SoundTestPopoverPositionButton * self;
	GtkImage* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	ca_proplist* proplist = NULL;
	ca_proplist* _tmp3_ = NULL;
	gchar* _tmp4_;
	gchar* _tmp5_;
	pa_channel_position_t _tmp6_;
	const gchar* _tmp7_;
	gchar* _tmp8_;
	gchar* _tmp9_;
	ca_context* canberra = NULL;
	ca_context* _tmp10_;
#line 220 "../src/TestPopover.vala"
	self = (SoundTestPopoverPositionButton*) base;
#line 221 "../src/TestPopover.vala"
	self->priv->playing = TRUE;
#line 222 "../src/TestPopover.vala"
	_tmp0_ = self->priv->image;
#line 222 "../src/TestPopover.vala"
	_tmp1_ = sound_test_popover_position_button_get_icon (self);
#line 222 "../src/TestPopover.vala"
	_tmp2_ = _tmp1_;
#line 222 "../src/TestPopover.vala"
	g_object_set (_tmp0_, "icon-name", _tmp2_, NULL);
#line 222 "../src/TestPopover.vala"
	_g_free0 (_tmp2_);
#line 224 "../src/TestPopover.vala"
	ca_proplist_create (&_tmp3_);
#line 224 "../src/TestPopover.vala"
	_ca_proplist_destroy0 (proplist);
#line 224 "../src/TestPopover.vala"
	proplist = _tmp3_;
#line 225 "../src/TestPopover.vala"
	ca_proplist_sets (proplist, CA_PROP_MEDIA_ROLE, "test");
#line 226 "../src/TestPopover.vala"
	_tmp4_ = sound_test_popover_position_button_get_pretty_position (self);
#line 226 "../src/TestPopover.vala"
	_tmp5_ = _tmp4_;
#line 226 "../src/TestPopover.vala"
	ca_proplist_sets (proplist, CA_PROP_MEDIA_NAME, _tmp5_);
#line 226 "../src/TestPopover.vala"
	_g_free0 (_tmp5_);
#line 227 "../src/TestPopover.vala"
	_tmp6_ = self->priv->_pa_position;
#line 227 "../src/TestPopover.vala"
	_tmp7_ = pa_channel_position_to_string (_tmp6_);
#line 227 "../src/TestPopover.vala"
	ca_proplist_sets (proplist, CA_PROP_CANBERRA_FORCE_CHANNEL, _tmp7_);
#line 228 "../src/TestPopover.vala"
	ca_proplist_sets (proplist, CA_PROP_CANBERRA_ENABLE, "1");
#line 229 "../src/TestPopover.vala"
	_tmp8_ = sound_test_popover_position_button_get_sound_name (self);
#line 229 "../src/TestPopover.vala"
	_tmp9_ = _tmp8_;
#line 229 "../src/TestPopover.vala"
	ca_proplist_sets (proplist, CA_PROP_EVENT_ID, _tmp9_);
#line 229 "../src/TestPopover.vala"
	_g_free0 (_tmp9_);
#line 230 "../src/TestPopover.vala"
	_tmp10_ = canberra_gtk4_context_get ();
#line 230 "../src/TestPopover.vala"
	canberra = _tmp10_;
#line 231 "../src/TestPopover.vala"
	ca_context_play_full (canberra, (guint32) 1, proplist, _sound_test_popover_position_button_play_full_callback_ca_finishcallback, self);
#line 220 "../src/TestPopover.vala"
	_ca_proplist_destroy0 (proplist);
#line 1192 "TestPopover.c"
}

static void
sound_test_popover_position_button_play_full_callback (SoundTestPopoverPositionButton* self,
                                                       ca_context* c,
                                                       guint32 id,
                                                       gint code)
{
	GtkImage* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
#line 234 "../src/TestPopover.vala"
	g_return_if_fail (self != NULL);
#line 234 "../src/TestPopover.vala"
	g_return_if_fail (c != NULL);
#line 235 "../src/TestPopover.vala"
	self->priv->playing = FALSE;
#line 236 "../src/TestPopover.vala"
	_tmp0_ = self->priv->image;
#line 236 "../src/TestPopover.vala"
	_tmp1_ = sound_test_popover_position_button_get_icon (self);
#line 236 "../src/TestPopover.vala"
	_tmp2_ = _tmp1_;
#line 236 "../src/TestPopover.vala"
	g_object_set (_tmp0_, "icon-name", _tmp2_, NULL);
#line 236 "../src/TestPopover.vala"
	_g_free0 (_tmp2_);
#line 1220 "TestPopover.c"
}

pa_channel_position_t
sound_test_popover_position_button_get_pa_position (SoundTestPopoverPositionButton* self)
{
	pa_channel_position_t result;
#line 132 "../src/TestPopover.vala"
	g_return_val_if_fail (self != NULL, 0);
#line 132 "../src/TestPopover.vala"
	result = self->priv->_pa_position;
#line 132 "../src/TestPopover.vala"
	return result;
#line 1233 "TestPopover.c"
}

static void
sound_test_popover_position_button_set_pa_position (SoundTestPopoverPositionButton* self,
                                                    pa_channel_position_t value)
{
	pa_channel_position_t old_value;
#line 132 "../src/TestPopover.vala"
	g_return_if_fail (self != NULL);
#line 132 "../src/TestPopover.vala"
	old_value = sound_test_popover_position_button_get_pa_position (self);
#line 132 "../src/TestPopover.vala"
	if (old_value != value) {
#line 132 "../src/TestPopover.vala"
		self->priv->_pa_position = value;
#line 132 "../src/TestPopover.vala"
		g_object_notify_by_pspec ((GObject *) self, sound_test_popover_position_button_properties[SOUND_TEST_POPOVER_POSITION_BUTTON_PA_POSITION_PROPERTY]);
#line 1251 "TestPopover.c"
	}
}

static GObject *
sound_test_popover_position_button_constructor (GType type,
                                                guint n_construct_properties,
                                                GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	SoundTestPopoverPositionButton * self;
	gchar* _tmp0_;
	gchar* _tmp1_;
	GtkImage* _tmp2_ = NULL;
	GtkImage* _tmp3_;
#line 140 "../src/TestPopover.vala"
	parent_class = G_OBJECT_CLASS (sound_test_popover_position_button_parent_class);
#line 140 "../src/TestPopover.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 140 "../src/TestPopover.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SOUND_TEST_POPOVER_TYPE_POSITION_BUTTON, SoundTestPopoverPositionButton);
#line 141 "../src/TestPopover.vala"
	gtk_widget_add_css_class ((GtkWidget*) self, GRANITE_STYLE_CLASS_FLAT);
#line 143 "../src/TestPopover.vala"
	_tmp0_ = sound_test_popover_position_button_get_icon (self);
#line 143 "../src/TestPopover.vala"
	_tmp1_ = _tmp0_;
#line 143 "../src/TestPopover.vala"
	_tmp2_ = (GtkImage*) gtk_image_new_from_icon_name (_tmp1_);
#line 143 "../src/TestPopover.vala"
	gtk_image_set_pixel_size (_tmp2_, 48);
#line 143 "../src/TestPopover.vala"
	g_object_ref_sink (_tmp2_);
#line 143 "../src/TestPopover.vala"
	_g_object_unref0 (self->priv->image);
#line 143 "../src/TestPopover.vala"
	self->priv->image = _tmp2_;
#line 143 "../src/TestPopover.vala"
	_g_free0 (_tmp1_);
#line 147 "../src/TestPopover.vala"
	_tmp3_ = self->priv->image;
#line 147 "../src/TestPopover.vala"
	gtk_button_set_child ((GtkButton*) self, (GtkWidget*) _tmp3_);
#line 140 "../src/TestPopover.vala"
	return obj;
#line 1297 "TestPopover.c"
}

static void
sound_test_popover_position_button_class_init (SoundTestPopoverPositionButtonClass * klass,
                                               gpointer klass_data)
{
#line 131 "../src/TestPopover.vala"
	sound_test_popover_position_button_parent_class = g_type_class_peek_parent (klass);
#line 131 "../src/TestPopover.vala"
	g_type_class_adjust_private_offset (klass, &SoundTestPopoverPositionButton_private_offset);
#line 131 "../src/TestPopover.vala"
	((GtkButtonClass *) klass)->clicked = (void (*) (GtkButton*)) sound_test_popover_position_button_real_clicked;
#line 131 "../src/TestPopover.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_sound_test_popover_position_button_get_property;
#line 131 "../src/TestPopover.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_sound_test_popover_position_button_set_property;
#line 131 "../src/TestPopover.vala"
	G_OBJECT_CLASS (klass)->constructor = sound_test_popover_position_button_constructor;
#line 131 "../src/TestPopover.vala"
	G_OBJECT_CLASS (klass)->finalize = sound_test_popover_position_button_finalize;
#line 131 "../src/TestPopover.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), SOUND_TEST_POPOVER_POSITION_BUTTON_PA_POSITION_PROPERTY, sound_test_popover_position_button_properties[SOUND_TEST_POPOVER_POSITION_BUTTON_PA_POSITION_PROPERTY] = g_param_spec_int ("pa-position", "pa-position", "pa-position", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE | G_PARAM_WRITABLE | G_PARAM_CONSTRUCT_ONLY));
#line 1320 "TestPopover.c"
}

static void
sound_test_popover_position_button_instance_init (SoundTestPopoverPositionButton * self,
                                                  gpointer klass)
{
#line 131 "../src/TestPopover.vala"
	self->priv = sound_test_popover_position_button_get_instance_private (self);
#line 133 "../src/TestPopover.vala"
	self->priv->playing = FALSE;
#line 1331 "TestPopover.c"
}

static void
sound_test_popover_position_button_finalize (GObject * obj)
{
	SoundTestPopoverPositionButton * self;
#line 131 "../src/TestPopover.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SOUND_TEST_POPOVER_TYPE_POSITION_BUTTON, SoundTestPopoverPositionButton);
#line 134 "../src/TestPopover.vala"
	_g_object_unref0 (self->priv->image);
#line 131 "../src/TestPopover.vala"
	G_OBJECT_CLASS (sound_test_popover_position_button_parent_class)->finalize (obj);
#line 1344 "TestPopover.c"
}

static GType
sound_test_popover_position_button_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SoundTestPopoverPositionButtonClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sound_test_popover_position_button_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SoundTestPopoverPositionButton), 0, (GInstanceInitFunc) sound_test_popover_position_button_instance_init, NULL };
	GType sound_test_popover_position_button_type_id;
	sound_test_popover_position_button_type_id = g_type_register_static (gtk_button_get_type (), "SoundTestPopoverPositionButton", &g_define_type_info, 0);
	SoundTestPopoverPositionButton_private_offset = g_type_add_instance_private (sound_test_popover_position_button_type_id, sizeof (SoundTestPopoverPositionButtonPrivate));
	return sound_test_popover_position_button_type_id;
}

GType
sound_test_popover_position_button_get_type (void)
{
	static volatile gsize sound_test_popover_position_button_type_id__once = 0;
	if (g_once_init_enter (&sound_test_popover_position_button_type_id__once)) {
		GType sound_test_popover_position_button_type_id;
		sound_test_popover_position_button_type_id = sound_test_popover_position_button_get_type_once ();
		g_once_init_leave (&sound_test_popover_position_button_type_id__once, sound_test_popover_position_button_type_id);
	}
	return sound_test_popover_position_button_type_id__once;
}

static void
_vala_sound_test_popover_position_button_get_property (GObject * object,
                                                       guint property_id,
                                                       GValue * value,
                                                       GParamSpec * pspec)
{
	SoundTestPopoverPositionButton * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SOUND_TEST_POPOVER_TYPE_POSITION_BUTTON, SoundTestPopoverPositionButton);
#line 131 "../src/TestPopover.vala"
	switch (property_id) {
#line 131 "../src/TestPopover.vala"
		case SOUND_TEST_POPOVER_POSITION_BUTTON_PA_POSITION_PROPERTY:
#line 131 "../src/TestPopover.vala"
		g_value_set_int (value, sound_test_popover_position_button_get_pa_position (self));
#line 131 "../src/TestPopover.vala"
		break;
#line 1385 "TestPopover.c"
		default:
#line 131 "../src/TestPopover.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 131 "../src/TestPopover.vala"
		break;
#line 1391 "TestPopover.c"
	}
}

static void
_vala_sound_test_popover_position_button_set_property (GObject * object,
                                                       guint property_id,
                                                       const GValue * value,
                                                       GParamSpec * pspec)
{
	SoundTestPopoverPositionButton * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, SOUND_TEST_POPOVER_TYPE_POSITION_BUTTON, SoundTestPopoverPositionButton);
#line 131 "../src/TestPopover.vala"
	switch (property_id) {
#line 131 "../src/TestPopover.vala"
		case SOUND_TEST_POPOVER_POSITION_BUTTON_PA_POSITION_PROPERTY:
#line 131 "../src/TestPopover.vala"
		sound_test_popover_position_button_set_pa_position (self, g_value_get_int (value));
#line 131 "../src/TestPopover.vala"
		break;
#line 1411 "TestPopover.c"
		default:
#line 131 "../src/TestPopover.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 131 "../src/TestPopover.vala"
		break;
#line 1417 "TestPopover.c"
	}
}

static void
_sound_test_popover___lambda23_ (SoundTestPopover* self)
{
#line 46 "../src/TestPopover.vala"
	sound_test_popover_default_changed (self);
#line 1426 "TestPopover.c"
}

static void
__sound_test_popover___lambda23__g_object_notify (GObject* _sender,
                                                  GParamSpec* pspec,
                                                  gpointer self)
{
#line 45 "../src/TestPopover.vala"
	_sound_test_popover___lambda23_ ((SoundTestPopover*) self);
#line 1436 "TestPopover.c"
}

static GObject *
sound_test_popover_constructor (GType type,
                                guint n_construct_properties,
                                GObjectConstructParam * construct_properties)
{
	GObject * obj;
	GObjectClass * parent_class;
	SoundTestPopover * self;
	GtkGrid* _tmp0_ = NULL;
	AdwAvatar* me = NULL;
	gchar* _tmp1_;
	AdwAvatar* _tmp2_ = NULL;
	GtkGrid* _tmp3_;
	AdwAvatar* _tmp4_;
	GtkGrid* _tmp5_;
	SoundPulseAudioManager* pam = NULL;
	SoundPulseAudioManager* _tmp6_;
	SoundPulseAudioManager* _tmp7_;
	GtkIconTheme* icon_theme = NULL;
	GdkDisplay* _tmp8_;
	GtkIconTheme* _tmp9_;
	GtkIconTheme* _tmp10_;
	GtkIconTheme* _tmp11_;
#line 27 "../src/TestPopover.vala"
	parent_class = G_OBJECT_CLASS (sound_test_popover_parent_class);
#line 27 "../src/TestPopover.vala"
	obj = parent_class->constructor (type, n_construct_properties, construct_properties);
#line 27 "../src/TestPopover.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SOUND_TYPE_TEST_POPOVER, SoundTestPopover);
#line 28 "../src/TestPopover.vala"
	_tmp0_ = (GtkGrid*) gtk_grid_new ();
#line 28 "../src/TestPopover.vala"
	gtk_widget_set_margin_top ((GtkWidget*) _tmp0_, 12);
#line 28 "../src/TestPopover.vala"
	gtk_widget_set_margin_end ((GtkWidget*) _tmp0_, 12);
#line 28 "../src/TestPopover.vala"
	gtk_widget_set_margin_bottom ((GtkWidget*) _tmp0_, 12);
#line 28 "../src/TestPopover.vala"
	gtk_widget_set_margin_start ((GtkWidget*) _tmp0_, 12);
#line 28 "../src/TestPopover.vala"
	gtk_grid_set_column_spacing (_tmp0_, 6);
#line 28 "../src/TestPopover.vala"
	gtk_grid_set_row_spacing (_tmp0_, 6);
#line 28 "../src/TestPopover.vala"
	g_object_ref_sink (_tmp0_);
#line 28 "../src/TestPopover.vala"
	_g_object_unref0 (self->priv->main_grid);
#line 28 "../src/TestPopover.vala"
	self->priv->main_grid = _tmp0_;
#line 37 "../src/TestPopover.vala"
	_tmp1_ = g_strdup ("avatar-default-symbolic");
#line 37 "../src/TestPopover.vala"
	_tmp2_ = (AdwAvatar*) adw_avatar_new (48, NULL, TRUE);
#line 37 "../src/TestPopover.vala"
	adw_avatar_set_icon_name (_tmp2_, _tmp1_);
#line 37 "../src/TestPopover.vala"
	_g_free0 (_tmp1_);
#line 37 "../src/TestPopover.vala"
	g_object_ref_sink (_tmp2_);
#line 37 "../src/TestPopover.vala"
	me = _tmp2_;
#line 40 "../src/TestPopover.vala"
	_tmp3_ = self->priv->main_grid;
#line 40 "../src/TestPopover.vala"
	_tmp4_ = me;
#line 40 "../src/TestPopover.vala"
	gtk_grid_attach (_tmp3_, (GtkWidget*) _tmp4_, 2, 1, 1, 1);
#line 42 "../src/TestPopover.vala"
	_tmp5_ = self->priv->main_grid;
#line 42 "../src/TestPopover.vala"
	gtk_popover_set_child ((GtkPopover*) self, (GtkWidget*) _tmp5_);
#line 44 "../src/TestPopover.vala"
	_tmp6_ = sound_pulse_audio_manager_get_default ();
#line 44 "../src/TestPopover.vala"
	pam = _tmp6_;
#line 45 "../src/TestPopover.vala"
	_tmp7_ = pam;
#line 45 "../src/TestPopover.vala"
	g_signal_connect_object ((GObject*) _tmp7_, "notify::default-output", (GCallback) __sound_test_popover___lambda23__g_object_notify, self, 0);
#line 49 "../src/TestPopover.vala"
	_tmp8_ = gdk_display_get_default ();
#line 49 "../src/TestPopover.vala"
	_tmp9_ = gtk_icon_theme_get_for_display (_tmp8_);
#line 49 "../src/TestPopover.vala"
	_tmp10_ = _g_object_ref0 (_tmp9_);
#line 49 "../src/TestPopover.vala"
	icon_theme = _tmp10_;
#line 50 "../src/TestPopover.vala"
	_tmp11_ = icon_theme;
#line 50 "../src/TestPopover.vala"
	gtk_icon_theme_add_resource_path (_tmp11_, "/io/elementary/settings/sound/icons/");
#line 27 "../src/TestPopover.vala"
	_g_object_unref0 (icon_theme);
#line 27 "../src/TestPopover.vala"
	_g_object_unref0 (me);
#line 27 "../src/TestPopover.vala"
	return obj;
#line 1536 "TestPopover.c"
}

static void
sound_test_popover_class_init (SoundTestPopoverClass * klass,
                               gpointer klass_data)
{
#line 23 "../src/TestPopover.vala"
	sound_test_popover_parent_class = g_type_class_peek_parent (klass);
#line 23 "../src/TestPopover.vala"
	g_type_class_adjust_private_offset (klass, &SoundTestPopover_private_offset);
#line 23 "../src/TestPopover.vala"
	G_OBJECT_CLASS (klass)->constructor = sound_test_popover_constructor;
#line 23 "../src/TestPopover.vala"
	G_OBJECT_CLASS (klass)->finalize = sound_test_popover_finalize;
#line 1551 "TestPopover.c"
}

static void
sound_test_popover_instance_init (SoundTestPopover * self,
                                  gpointer klass)
{
#line 23 "../src/TestPopover.vala"
	self->priv = sound_test_popover_get_instance_private (self);
#line 1560 "TestPopover.c"
}

static void
sound_test_popover_finalize (GObject * obj)
{
	SoundTestPopover * self;
#line 23 "../src/TestPopover.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, SOUND_TYPE_TEST_POPOVER, SoundTestPopover);
#line 24 "../src/TestPopover.vala"
	_g_object_unref0 (self->priv->main_grid);
#line 25 "../src/TestPopover.vala"
	_g_object_unref0 (self->priv->default_device);
#line 23 "../src/TestPopover.vala"
	G_OBJECT_CLASS (sound_test_popover_parent_class)->finalize (obj);
#line 1575 "TestPopover.c"
}

static GType
sound_test_popover_get_type_once (void)
{
	static const GTypeInfo g_define_type_info = { sizeof (SoundTestPopoverClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) sound_test_popover_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (SoundTestPopover), 0, (GInstanceInitFunc) sound_test_popover_instance_init, NULL };
	GType sound_test_popover_type_id;
	sound_test_popover_type_id = g_type_register_static (gtk_popover_get_type (), "SoundTestPopover", &g_define_type_info, 0);
	SoundTestPopover_private_offset = g_type_add_instance_private (sound_test_popover_type_id, sizeof (SoundTestPopoverPrivate));
	return sound_test_popover_type_id;
}

GType
sound_test_popover_get_type (void)
{
	static volatile gsize sound_test_popover_type_id__once = 0;
	if (g_once_init_enter (&sound_test_popover_type_id__once)) {
		GType sound_test_popover_type_id;
		sound_test_popover_type_id = sound_test_popover_get_type_once ();
		g_once_init_leave (&sound_test_popover_type_id__once, sound_test_popover_type_id);
	}
	return sound_test_popover_type_id__once;
}

